/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core/ES2015/type";
import { HorizontalAlignment_$type } from "igniteui-angular-core/ES2015/HorizontalAlignment";
import { VerticalAlignment_$type } from "igniteui-angular-core/ES2015/VerticalAlignment";
import { Visibility_$type } from "igniteui-angular-core/ES2015/Visibility";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
export class XYChart extends DomainChart {
    constructor() {
        super(...arguments);
        this.h7 = null;
        this.h8 = null;
        this.il = 0;
        this.io = 5;
        this.im = 0;
        this.ik = 5;
        this.i3 = 5;
        this.i5 = 0;
        this.i4 = 5;
        this.i2 = 0;
        this.nh = null;
        this.no = null;
        this.ix = 0;
        this.je = 0;
        this.iw = NaN;
        this.jd = NaN;
        this.iz = NaN;
        this.jg = NaN;
        this.iy = NaN;
        this.jf = NaN;
        this.iv = NaN;
        this.jc = NaN;
        this.nn = null;
        this.nu = null;
        this.kn = null;
        this.kq = null;
        this.kp = null;
        this.ks = null;
        this.kj = null;
        this.kk = null;
        this.ni = null;
        this.np = null;
        this.ip = 1;
        this.i6 = 1;
        this.iq = 1;
        this.i7 = 0;
        this.nk = null;
        this.nr = null;
        this.nl = null;
        this.ns = null;
        this.ir = 1;
        this.i8 = 1;
        this.is = 5;
        this.i9 = 0;
        this.nm = null;
        this.nt = null;
        this.it = 2;
        this.ja = 2;
        this.ko = null;
        this.kr = null;
        this.nj = null;
        this.nq = null;
        this.ij = 0;
        this.i1 = 0;
        this.ii = NaN;
        this.i0 = NaN;
        this.iu = 0;
        this.jb = -90;
        this.id = false;
        this.ie = false;
        this.nc = 1;
        this.ob = 1;
        this.nb = 1;
        this.nd = 2;
        this.n9 = 0;
        this.oa = 1;
        this.of = 0;
        this.og = 0;
        this.ib = 2;
    }
    provideContainer(a) {
        if (a != null) {
            let b = this.h5();
            let c = this.h6();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        super.provideContainer(a);
    }
    gh() {
        super.gh();
        let a = this.h5();
        let b = this.h6();
        if (a != null && a.aw != null) {
            this.nv = a.aw.textColor;
        }
        if (b != null && b.aw != null) {
            this.n2 = b.aw.textColor;
        }
    }
    g0(a, b, c) {
        super.g0(a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.m5((d) => d.leftMargin = this.jo);
                break;
            case "XAxisLabelTopMargin":
                this.m5((d) => d.topMargin = this.jq);
                break;
            case "XAxisLabelRightMargin":
                this.m5((d) => d.rightMargin = this.jp);
                break;
            case "XAxisLabelBottomMargin":
                this.m5((d) => d.bottomMargin = this.jn);
                break;
            case "YAxisLabelLeftMargin":
                this.m9((d) => d.leftMargin = this.j5);
                break;
            case "YAxisLabelTopMargin":
                this.m9((d) => d.topMargin = this.j7);
                break;
            case "YAxisLabelRightMargin":
                this.m9((d) => d.rightMargin = this.j6);
                break;
            case "YAxisLabelBottomMargin":
                this.m9((d) => d.bottomMargin = this.j4);
                break;
            case "XAxisLabelTextColor":
                this.m5((d) => d.textColor = this.nv);
                break;
            case "YAxisLabelTextColor":
                this.m9((d) => d.textColor = this.n2);
                break;
            case "XAxisTitleMargin":
                this.m6((d) => d.margin = this.jz);
                break;
            case "YAxisTitleMargin":
                this.na((d) => d.margin = this.kg);
                break;
            case "XAxisTitleLeftMargin":
                this.m6((d) => d.leftMargin = this.jy);
                break;
            case "YAxisTitleLeftMargin":
                this.na((d) => d.leftMargin = this.kf);
                break;
            case "XAxisTitleTopMargin":
                this.m6((d) => d.topMargin = this.j1);
                break;
            case "YAxisTitleTopMargin":
                this.na((d) => d.topMargin = this.ki);
                break;
            case "XAxisTitleRightMargin":
                this.m6((d) => d.rightMargin = this.j0);
                break;
            case "YAxisTitleRightMargin":
                this.na((d) => d.rightMargin = this.kh);
                break;
            case "XAxisTitleBottomMargin":
                this.m6((d) => d.bottomMargin = this.jx);
                break;
            case "YAxisTitleBottomMargin":
                this.na((d) => d.bottomMargin = this.ke);
                break;
            case "XAxisTitleTextColor":
                this.m6((d) => d.textColor = this.n1);
                break;
            case "YAxisTitleTextColor":
                this.na((d) => d.textColor = this.n8);
                break;
            case "XAxisFormatLabel":
                this.m3((d) => d.ar = this.h9);
                break;
            case "YAxisFormatLabel":
                this.m7((d) => d.ar = this.ia);
                break;
        }
    }
    get h9() {
        return this.h7;
    }
    set h9(a) {
        let b = this.h9;
        if (a != b) {
            this.h7 = a;
            this.gz("XAxisFormatLabel", b, this.h9);
        }
    }
    get ia() {
        return this.h8;
    }
    set ia(a) {
        let b = this.ia;
        if (a != b) {
            this.h8 = a;
            this.gz("YAxisFormatLabel", b, this.ia);
        }
    }
    get jo() {
        return this.il;
    }
    set jo(a) {
        let b = this.jo;
        if (a != b) {
            this.il = a;
            this.gz("XAxisLabelLeftMargin", b, this.jo);
        }
    }
    get jq() {
        return this.io;
    }
    set jq(a) {
        let b = this.jq;
        if (a != b) {
            this.io = a;
            this.gz("XAxisLabelTopMargin", b, this.jq);
        }
    }
    get jp() {
        return this.im;
    }
    set jp(a) {
        let b = this.jp;
        if (a != b) {
            this.im = a;
            this.gz("XAxisLabelRightMargin", b, this.jp);
        }
    }
    get jn() {
        return this.ik;
    }
    set jn(a) {
        let b = this.jn;
        if (a != b) {
            this.ik = a;
            this.gz("XAxisLabelBottomMargin", b, this.jn);
        }
    }
    get j5() {
        return this.i3;
    }
    set j5(a) {
        let b = this.j5;
        if (a != b) {
            this.i3 = a;
            this.gz("YAxisLabelLeftMargin", b, this.j5);
        }
    }
    get j7() {
        return this.i5;
    }
    set j7(a) {
        let b = this.j7;
        if (a != b) {
            this.i5 = a;
            this.gz("YAxisLabelTopMargin", b, this.j7);
        }
    }
    get j6() {
        return this.i4;
    }
    set j6(a) {
        let b = this.j6;
        if (a != b) {
            this.i4 = a;
            this.gz("YAxisLabelRightMargin", b, this.j6);
        }
    }
    get j4() {
        return this.i2;
    }
    set j4(a) {
        let b = this.j4;
        if (a != b) {
            this.i2 = a;
            this.gz("YAxisLabelBottomMargin", b, this.j4);
        }
    }
    get nv() {
        return this.nh;
    }
    set nv(a) {
        let b = this.nv;
        if (a != b) {
            this.nh = a;
            this.gz("XAxisLabelTextColor", b, this.nv);
        }
    }
    get n2() {
        return this.no;
    }
    set n2(a) {
        let b = this.n2;
        if (a != b) {
            this.no = a;
            this.gz("YAxisLabelTextColor", b, this.n2);
        }
    }
    get jz() {
        return this.ix;
    }
    set jz(a) {
        let b = this.jz;
        if (a != b) {
            this.ix = a;
            this.gz("XAxisTitleMargin", b, this.jz);
        }
    }
    get kg() {
        return this.je;
    }
    set kg(a) {
        let b = this.kg;
        if (a != b) {
            this.je = a;
            this.gz("YAxisTitleMargin", b, this.kg);
        }
    }
    get jy() {
        return this.iw;
    }
    set jy(a) {
        let b = this.jy;
        if (a != b) {
            this.iw = a;
            this.gz("XAxisTitleLeftMargin", b, this.jy);
        }
    }
    get kf() {
        return this.jd;
    }
    set kf(a) {
        let b = this.kf;
        if (a != b) {
            this.jd = a;
            this.gz("YAxisTitleLeftMargin", b, this.kf);
        }
    }
    get j1() {
        return this.iz;
    }
    set j1(a) {
        let b = this.j1;
        if (a != b) {
            this.iz = a;
            this.gz("XAxisTitleTopMargin", b, this.j1);
        }
    }
    get ki() {
        return this.jg;
    }
    set ki(a) {
        let b = this.ki;
        if (a != b) {
            this.jg = a;
            this.gz("YAxisTitleTopMargin", b, this.ki);
        }
    }
    get j0() {
        return this.iy;
    }
    set j0(a) {
        let b = this.j0;
        if (a != b) {
            this.iy = a;
            this.gz("XAxisTitleRightMargin", b, this.j0);
        }
    }
    get kh() {
        return this.jf;
    }
    set kh(a) {
        let b = this.kh;
        if (a != b) {
            this.jf = a;
            this.gz("YAxisTitleRightMargin", b, this.kh);
        }
    }
    get jx() {
        return this.iv;
    }
    set jx(a) {
        let b = this.jx;
        if (a != b) {
            this.iv = a;
            this.gz("XAxisTitleBottomMargin", b, this.jx);
        }
    }
    get ke() {
        return this.jc;
    }
    set ke(a) {
        let b = this.ke;
        if (a != b) {
            this.jc = a;
            this.gz("YAxisTitleBottomMargin", b, this.ke);
        }
    }
    get n1() {
        return this.nn;
    }
    set n1(a) {
        let b = this.n1;
        if (a != b) {
            this.nn = a;
            this.gz("XAxisTitleTextColor", b, this.n1);
        }
    }
    get n8() {
        return this.nu;
    }
    set n8(a) {
        let b = this.n8;
        if (a != b) {
            this.nu = a;
            this.gz("YAxisTitleTextColor", b, this.n8);
        }
    }
    g1(a, b, c) {
        super.g1(a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.m5((d) => d.textStyle = this.k4);
                break;
            case "YAxisLabelTextStyle":
                this.m9((d) => d.textStyle = this.l6);
                break;
            case "XAxisTitleTextStyle":
                this.m6((d) => d.textStyle = this.ls);
                break;
            case "YAxisTitleTextStyle":
                this.na((d) => d.textStyle = this.mu);
                break;
        }
    }
    get k4() {
        return this.kn;
    }
    set k4(a) {
        let b = this.k4;
        if (a != b) {
            this.kn = a;
            this.gz("XAxisLabelTextStyle", b, this.k4);
        }
    }
    get l6() {
        return this.kq;
    }
    set l6(a) {
        let b = this.l6;
        if (a != b) {
            this.kq = a;
            this.gz("YAxisLabelTextStyle", b, this.l6);
        }
    }
    get ls() {
        return this.kp;
    }
    set ls(a) {
        let b = this.ls;
        if (a != b) {
            this.kp = a;
            this.gz("XAxisTitleTextStyle", b, this.ls);
        }
    }
    get mu() {
        return this.ks;
    }
    set mu(a) {
        let b = this.mu;
        if (a != b) {
            this.ks = a;
            this.gz("YAxisTitleTextStyle", b, this.mu);
        }
    }
    m0(a) {
        this.mx(a, (b) => b.leftMargin = this.jo);
        this.mx(a, (b) => b.topMargin = this.jq);
        this.mx(a, (b) => b.rightMargin = this.jp);
        this.mx(a, (b) => b.bottomMargin = this.jn);
        this.mx(a, (b) => b.textColor = this.nv);
        this.my(a, (b) => b.textColor = this.n1);
        this.my(a, (b) => b.leftMargin = this.jy);
        this.my(a, (b) => b.topMargin = this.j1);
        this.my(a, (b) => b.rightMargin = this.j0);
        this.my(a, (b) => b.bottomMargin = this.jx);
        this.mx(a, (b) => b.textStyle = this.k4);
        this.my(a, (b) => b.textStyle = this.ls);
    }
    m2(a) {
        this.mx(a, (b) => b.leftMargin = this.j5);
        this.mx(a, (b) => b.topMargin = this.j7);
        this.mx(a, (b) => b.rightMargin = this.j6);
        this.mx(a, (b) => b.bottomMargin = this.j4);
        this.mx(a, (b) => b.textColor = this.n2);
        this.my(a, (b) => b.textColor = this.n8);
        this.my(a, (b) => b.leftMargin = this.kf);
        this.my(a, (b) => b.topMargin = this.ki);
        this.my(a, (b) => b.rightMargin = this.kh);
        this.my(a, (b) => b.bottomMargin = this.ke);
        this.mx(a, (b) => b.textStyle = this.l6);
        this.my(a, (b) => b.textStyle = this.mu);
    }
    hg(a) {
        let b = this.u(a);
        let c = this.aq(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.ek(a);
        c.fr = this.el(a, b);
        this.dataChart.series.add(c);
    }
    m3(a) {
        this.m4(a, null);
    }
    m4(a, b) {
        a(this.h5());
    }
    m8(a, b) {
        a(this.h6());
    }
    m7(a) {
        this.m8(a, true);
    }
    m6(a) {
        this.my(this.h5(), a);
    }
    na(a) {
        this.my(this.h6(), a);
    }
    m9(a) {
        this.mx(this.h6(), a);
    }
    m5(a) {
        this.mx(this.h5(), a);
    }
    jh(a) {
        let b = this.h5();
        return b.dt(a, new ScalerParams(1, this.h4, this.h3, b.b8));
    }
    jj(a) {
        let b = this.h5();
        return b.dw(a, new ScalerParams(1, this.h4, this.h3, b.b8));
    }
    ji(a) {
        let b = this.h6();
        return b.dt(a, new ScalerParams(1, this.h4, this.h3, b.b8));
    }
    jk(a) {
        let b = this.h6();
        return b.dw(a, new ScalerParams(1, this.h4, this.h3, b.b8));
    }
    he(a) {
        super.he(a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            let b = this.h5();
            let c = this.h6();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    }
    static kt(a, b) {
        for (let c of fromEnum(b)) {
            let d = c.findMatchingHint(16);
            if (d != null) {
                let e = d.path;
                return e;
            }
        }
        return null;
    }
    gc(a) {
        super.gc(a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.h5());
            this.dataChart.axes.add(this.h6());
        }
    }
    mz(a) {
        if (a != null && this.dh != null && a.ep == null) {
            a.provideRenderer(this.dh);
        }
        a.ic = this.nw;
        a.d0 = this.jr;
        a.id = this.nx;
        a.d3 = this.js;
        a.ig = this.nz;
        a.ek = this.jt;
        a.ie = this.ny;
        a.el = this.ju;
        a.ih = this.n0;
        a.em = this.jv;
        a.cn = true;
        let b = a == this.h5();
        if (b) {
            a.f1 = this.lj;
        }
        a.e2 = this.kl;
        this.mx(a, (c) => c.angle = this.jm);
        this.mx(a, (c) => {
            if (c.extent != this.jl) {
                c.extent = this.jl;
            }
        });
        this.mx(a, (c) => c.horizontalAlignment = this.ne);
        this.mx(a, (c) => c.verticalAlignment = this.oc);
        this.mx(a, (c) => c.visibility = this.oh);
        this.my(a, (c) => c.horizontalAlignment = this.nf);
        this.my(a, (c) => c.angle = this.jw);
        this.m0(a);
    }
    m1(a) {
        if (a == null) {
            return;
        }
        if (this.dh != null && a.ep == null) {
            a.provideRenderer(this.dh);
        }
        this.mx(a, (b) => b.angle = this.j3);
        this.mx(a, (b) => {
            if (b.extent != this.j2) {
                b.extent = this.j2;
            }
        });
        this.mx(a, (b) => b.horizontalAlignment = this.ng);
        this.mx(a, (b) => b.verticalAlignment = this.od);
        this.mx(a, (b) => b.visibility = this.oi);
        this.mx(a, (b) => b.location = this.ic);
        this.my(a, (b) => b.verticalAlignment = this.oe);
        this.my(a, (b) => b.angle = this.kd);
        a.ic = this.n3;
        a.d0 = this.j8;
        a.id = this.n4;
        a.d3 = this.j9;
        a.ig = this.n6;
        a.ek = this.ka;
        a.ie = this.n5;
        a.el = this.kb;
        a.ih = this.n7;
        a.em = this.kc;
        let b = a == this.h6();
        if (b) {
            a.f1 = this.ml;
        }
        this.m2(a);
    }
    f9() {
        super.f9();
        this.mz(this.h5());
        this.m1(this.h6());
    }
    mx(a, b) {
        if (a == null) {
            return;
        }
        if (a.aw == null) {
            a.aw = new AxisLabelSettings();
            a.aw.angle = a.dh();
            a.aw.bottomMargin = a.di();
            a.aw.leftMargin = a.dj();
            a.aw.rightMargin = a.dk();
            a.aw.topMargin = a.dl();
            a.aw.horizontalAlignment = a.h7();
            a.aw.location = a.ax();
            a.aw.verticalAlignment = a.i1();
        }
        b(a.aw);
    }
    my(a, b) {
        if (a == null) {
            return;
        }
        if (a.bc == null) {
            a.bc = new TitleSettings();
            a.bc.bottomMargin = a.dn();
            a.bc.leftMargin = a.dp();
            a.bc.rightMargin = a.dq();
            a.bc.topMargin = a.dr();
            a.bc.location = a.ay();
            a.bc.angle = a.dm();
            a.bc.horizontalAlignment = a.h8();
            a.bc.verticalAlignment = a.i2();
        }
        b(a.bc);
    }
    gz(a, b, c) {
        super.gz(a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.m5((d) => d.angle = this.jm);
                break;
            case "YAxisLabelAngle":
                this.m9((d) => d.angle = this.j3);
                break;
            case "XAxisLabelHorizontalAlignment":
                this.m5((d) => d.horizontalAlignment = this.ne);
                break;
            case "YAxisLabelHorizontalAlignment":
                this.m9((d) => d.horizontalAlignment = this.ng);
                break;
            case "XAxisLabelVerticalAlignment":
                this.m5((d) => d.verticalAlignment = this.oc);
                break;
            case "YAxisLabelVerticalAlignment":
                this.m9((d) => d.verticalAlignment = this.od);
                break;
            case "XAxisLabelVisibility":
                this.m5((d) => d.visibility = this.oh);
                break;
            case "YAxisLabelVisibility":
                this.m9((d) => d.visibility = this.oi);
                break;
            case "XAxisLabel":
                this.m3((d) => d.e2 = this.kl);
                break;
            case "YAxisLabel":
                this.m7((d) => d.e2 = this.km);
                break;
            case "XAxisTitleAngle":
                this.m6((d) => d.angle = this.jw);
                break;
            case "YAxisTitleAngle":
                this.na((d) => d.angle = this.kd);
                break;
            case "XAxisTitleAlignment":
                this.m6((d) => d.horizontalAlignment = this.nf);
                break;
            case "YAxisTitleAlignment":
                this.na((d) => d.verticalAlignment = this.oe);
                break;
            case "XAxisTitle":
                this.m3((d) => d.f1 = this.lj);
                break;
            case "YAxisTitle":
                this.m8((d) => d.f1 = this.ml, false);
                break;
            case "XAxisMajorStroke":
                this.m4((d) => d.ic = this.nw, a);
                break;
            case "YAxisMajorStroke":
                this.m7((d) => d.ic = this.n3);
                break;
            case "XAxisMajorStrokeThickness":
                this.m4((d) => d.d0 = this.jr, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.m7((d) => d.d0 = this.j8);
                break;
            case "XAxisMinorStroke":
                this.m3((d) => d.id = this.nx);
                break;
            case "YAxisMinorStroke":
                this.m7((d) => d.id = this.n4);
                break;
            case "XAxisMinorStrokeThickness":
                this.m3((d) => d.d3 = this.js);
                break;
            case "YAxisMinorStrokeThickness":
                this.m7((d) => d.d3 = this.j9);
                break;
            case "XAxisTickLength":
                this.m3((d) => d.el = this.ju);
                break;
            case "YAxisTickLength":
                this.m7((d) => d.el = this.kb);
                break;
            case "XAxisTickStroke":
                this.m3((d) => d.ih = this.n0);
                break;
            case "YAxisTickStroke":
                this.m7((d) => d.ih = this.n7);
                break;
            case "XAxisTickStrokeThickness":
                this.m3((d) => d.em = this.jv);
                break;
            case "YAxisTickStrokeThickness":
                this.m7((d) => d.em = this.kc);
                break;
            case "XAxisStroke":
                this.m3((d) => d.ig = this.nz);
                break;
            case "YAxisStroke":
                this.m7((d) => d.ig = this.n6);
                break;
            case "XAxisStrokeThickness":
                this.m3((d) => d.ek = this.jt);
                break;
            case "YAxisStrokeThickness":
                this.m7((d) => d.ek = this.ka);
                break;
            case "XAxisExtent":
                this.m5((d) => d.extent = this.jl);
                break;
            case "YAxisExtent":
                this.m9((d) => d.extent = this.j2);
                break;
            case "XAxisStrip":
                this.m3((d) => d.ie = this.ny);
                break;
            case "YAxisStrip":
                this.m7((d) => d.ie = this.n5);
                break;
            case "XAxisInverted":
                this.m3((d) => d.b8 = this.ig);
                break;
            case "YAxisInverted":
                this.m7((d) => d.b8 = this.ih);
                break;
            case "YAxisLabelLocation":
                this.m9((d) => d.location = this.ic);
                break;
        }
    }
    get kl() {
        return this.kj;
    }
    set kl(a) {
        let b = this.kl;
        if (a != b) {
            this.kj = a;
            this.gz("XAxisLabel", b, this.kl);
        }
    }
    get km() {
        return this.kk;
    }
    set km(a) {
        let b = this.km;
        if (a != b) {
            this.kk = a;
            this.gz("YAxisLabel", b, this.km);
        }
    }
    get nw() {
        return this.ni;
    }
    set nw(a) {
        let b = this.nw;
        if (a != b) {
            this.ni = a;
            this.gz("XAxisMajorStroke", b, this.nw);
        }
    }
    get n3() {
        return this.np;
    }
    set n3(a) {
        let b = this.n3;
        if (a != b) {
            this.np = a;
            this.gz("YAxisMajorStroke", b, this.n3);
        }
    }
    get jr() {
        return this.ip;
    }
    set jr(a) {
        let b = this.jr;
        if (a != b) {
            this.ip = a;
            this.gz("XAxisMajorStrokeThickness", b, this.jr);
        }
    }
    get j8() {
        return this.i6;
    }
    set j8(a) {
        let b = this.j8;
        if (a != b) {
            this.i6 = a;
            this.gz("YAxisMajorStrokeThickness", b, this.j8);
        }
    }
    get js() {
        return this.iq;
    }
    set js(a) {
        let b = this.js;
        if (a != b) {
            this.iq = a;
            this.gz("XAxisMinorStrokeThickness", b, this.js);
        }
    }
    get j9() {
        return this.i7;
    }
    set j9(a) {
        let b = this.j9;
        if (a != b) {
            this.i7 = a;
            this.gz("YAxisMinorStrokeThickness", b, this.j9);
        }
    }
    get ny() {
        return this.nk;
    }
    set ny(a) {
        let b = this.ny;
        if (a != b) {
            this.nk = a;
            this.gz("XAxisStrip", b, this.ny);
        }
    }
    get n5() {
        return this.nr;
    }
    set n5(a) {
        let b = this.n5;
        if (a != b) {
            this.nr = a;
            this.gz("YAxisStrip", b, this.n5);
        }
    }
    get nz() {
        return this.nl;
    }
    set nz(a) {
        let b = this.nz;
        if (a != b) {
            this.nl = a;
            this.gz("XAxisStroke", b, this.nz);
        }
    }
    get n6() {
        return this.ns;
    }
    set n6(a) {
        let b = this.n6;
        if (a != b) {
            this.ns = a;
            this.gz("YAxisStroke", b, this.n6);
        }
    }
    get jt() {
        return this.ir;
    }
    set jt(a) {
        let b = this.jt;
        if (a != b) {
            this.ir = a;
            this.gz("XAxisStrokeThickness", b, this.jt);
        }
    }
    get ka() {
        return this.i8;
    }
    set ka(a) {
        let b = this.ka;
        if (a != b) {
            this.i8 = a;
            this.gz("YAxisStrokeThickness", b, this.ka);
        }
    }
    get ju() {
        return this.is;
    }
    set ju(a) {
        let b = this.ju;
        if (a != b) {
            this.is = a;
            this.gz("XAxisTickLength", b, this.ju);
        }
    }
    get kb() {
        return this.i9;
    }
    set kb(a) {
        let b = this.kb;
        if (a != b) {
            this.i9 = a;
            this.gz("YAxisTickLength", b, this.kb);
        }
    }
    get n0() {
        return this.nm;
    }
    set n0(a) {
        let b = this.n0;
        if (a != b) {
            this.nm = a;
            this.gz("XAxisTickStroke", b, this.n0);
        }
    }
    get n7() {
        return this.nt;
    }
    set n7(a) {
        let b = this.n7;
        if (a != b) {
            this.nt = a;
            this.gz("YAxisTickStroke", b, this.n7);
        }
    }
    get jv() {
        return this.it;
    }
    set jv(a) {
        let b = this.jv;
        if (a != b) {
            this.it = a;
            this.gz("XAxisTickStrokeThickness", b, this.jv);
        }
    }
    get kc() {
        return this.ja;
    }
    set kc(a) {
        let b = this.kc;
        if (a != b) {
            this.ja = a;
            this.gz("YAxisTickStrokeThickness", b, this.kc);
        }
    }
    get lj() {
        return this.ko;
    }
    set lj(a) {
        let b = this.lj;
        if (a != b) {
            this.ko = a;
            this.gz("XAxisTitle", b, this.lj);
        }
    }
    get ml() {
        return this.kr;
    }
    set ml(a) {
        let b = this.ml;
        if (a != b) {
            this.kr = a;
            this.gz("YAxisTitle", b, this.ml);
        }
    }
    get nx() {
        return this.nj;
    }
    set nx(a) {
        let b = this.nx;
        if (a != b) {
            this.nj = a;
            this.gz("XAxisMinorStroke", b, this.nx);
        }
    }
    get n4() {
        return this.nq;
    }
    set n4(a) {
        let b = this.n4;
        if (a != b) {
            this.nq = a;
            this.gz("YAxisMinorStroke", b, this.n4);
        }
    }
    get jm() {
        return this.ij;
    }
    set jm(a) {
        let b = this.jm;
        if (a != b) {
            this.ij = a;
            this.gz("XAxisLabelAngle", b, this.jm);
        }
    }
    get j3() {
        return this.i1;
    }
    set j3(a) {
        let b = this.j3;
        if (a != b) {
            this.i1 = a;
            this.gz("YAxisLabelAngle", b, this.j3);
        }
    }
    get jl() {
        return this.ii;
    }
    set jl(a) {
        let b = this.jl;
        if (a != b) {
            this.ii = a;
            this.gz("XAxisExtent", b, this.jl);
        }
    }
    get j2() {
        return this.i0;
    }
    set j2(a) {
        let b = this.j2;
        if (a != b) {
            this.i0 = a;
            this.gz("YAxisExtent", b, this.j2);
        }
    }
    get jw() {
        return this.iu;
    }
    set jw(a) {
        let b = this.jw;
        if (a != b) {
            this.iu = a;
            this.gz("XAxisTitleAngle", b, this.jw);
        }
    }
    get kd() {
        return this.jb;
    }
    set kd(a) {
        let b = this.kd;
        if (a != b) {
            this.jb = a;
            this.gz("YAxisTitleAngle", b, this.kd);
        }
    }
    get ig() {
        return this.id;
    }
    set ig(a) {
        let b = this.ig;
        if (a != b) {
            this.id = a;
            this.gz("XAxisInverted", b, this.ig);
        }
    }
    get ih() {
        return this.ie;
    }
    set ih(a) {
        let b = this.ih;
        if (a != b) {
            this.ie = a;
            this.gz("YAxisInverted", b, this.ih);
        }
    }
    get nf() {
        return this.nc;
    }
    set nf(a) {
        let b = this.nf;
        if (a != b) {
            this.nc = a;
            this.gz("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nf));
        }
    }
    get oe() {
        return this.ob;
    }
    set oe(a) {
        let b = this.oe;
        if (a != b) {
            this.ob = a;
            this.gz("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oe));
        }
    }
    get ne() {
        return this.nb;
    }
    set ne(a) {
        let b = this.ne;
        if (a != b) {
            this.nb = a;
            this.gz("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ne));
        }
    }
    get_ng() {
        return this.nd;
    }
    set_ng(a) {
        let b = this.ng;
        if (a != b) {
            this.nd = a;
            this.gz("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ng));
        }
    }
    get ng() {
        return this.get_ng();
    }
    set ng(a) {
        this.set_ng(a);
    }
    get oc() {
        return this.n9;
    }
    set oc(a) {
        let b = this.oc;
        if (a != b) {
            this.n9 = a;
            this.gz("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oc));
        }
    }
    get od() {
        return this.oa;
    }
    set od(a) {
        let b = this.od;
        if (a != b) {
            this.oa = a;
            this.gz("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.od));
        }
    }
    get oh() {
        return this.of;
    }
    set oh(a) {
        let b = this.oh;
        if (a != b) {
            this.of = a;
            this.gz("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.oh));
        }
    }
    get oi() {
        return this.og;
    }
    set oi(a) {
        let b = this.oi;
        if (a != b) {
            this.og = a;
            this.gz("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.oi));
        }
    }
    get_ic() {
        return this.ib;
    }
    set_ic(a) {
        let b = this.ic;
        if (a != b) {
            this.ib = a;
            this.gz("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.ic));
        }
    }
    get ic() {
        return this.get_ic();
    }
    set ic(a) {
        this.set_ic(a);
    }
}
XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
//# sourceMappingURL=XYChart.js.map