import { Brush } from "igniteui-angular-core/ES5/Brush";
import { XYChart } from "./XYChart";
import { DomWrapper, EventArgs, IList, Type } from "igniteui-angular-core/ES5/type";
import { IZoomSlider } from "igniteui-angular-core/ES5/IZoomSlider";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { DataSeriesType } from "igniteui-angular-core/ES5/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-angular-core/ES5/IDataSeriesAdapterRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { IChartLegend } from "igniteui-angular-core/ES5/IChartLegend";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-angular-core/ES5/DataSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType } from "igniteui-angular-core/ES5/TrendLineType";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
export declare class FinancialChart extends XYChart {
    static $t: Type;
    protected g1(a: string, b: any, c: any): void;
    private v6(a, b);
    private v5(a, b);
    private v2(a, b);
    private we();
    private qb;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: Event): void;
    private ss;
    private sq;
    private sn;
    private sp;
    private sr;
    private so;
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private wp(a, b, c);
    private w3(a, b);
    private vn();
    private w1(a, b);
    setGridRows(): void;
    protected gh(): void;
    private wl();
    private wm();
    private wv();
    private vm();
    private wc();
    protected ge(a: XamDataChart): void;
    private w6(a);
    private w9();
    private w7(a);
    private w8(a);
    sa(): number;
    gp(source_: any, a: number, b: any): void;
    gq(source_: any, a: number, b: any): void;
    go(source_: any): void;
    gs(source_: any, a: number, b: any, c: any): void;
    protected gk(a: Series, b: number): void;
    private ph;
    private pi;
    private ta;
    th: any;
    private tb;
    ti: any;
    private s7;
    te: any;
    private tc;
    tj: any;
    private td;
    tk: any;
    private s8;
    tf: any;
    private s9;
    tg: any;
    private qz;
    q0: IZoomSlider;
    protected get_cr(): number;
    protected set_cr(a: number): void;
    protected get_bo(): boolean;
    protected set_bo(a: boolean): void;
    private r3;
    se: number;
    constructor();
    protected h5(): Axis;
    protected h6(): Axis;
    protected u(a: DataSeries): DataSeriesType;
    protected get_b3(): List$1<DataSeriesType>;
    protected readonly b3: List$1<DataSeriesType>;
    protected get_b2(): List$1<IDataSeriesAdapterRule>;
    protected readonly b2: List$1<IDataSeriesAdapterRule>;
    private o4(a);
    private qi(a);
    private o3(a);
    protected f2(): void;
    protected f0(a: Series, b: number): void;
    protected hf(a: DataSeries): void;
    protected hi(): void;
    private pm(a);
    private pl(a);
    private pv(a);
    private po(a);
    private ts(a);
    private o5(axisType_);
    private qj(axisType_);
    private qp();
    private qq();
    private qo();
    private qr();
    private readonly q6;
    private p5;
    private readonly p6;
    private readonly q9;
    private p3;
    private readonly p4;
    private readonly q7;
    private p7;
    private readonly p8;
    private readonly q8;
    private qc;
    private readonly qd;
    protected aq(a: DataSeries, b: DataSeriesType): Series;
    protected hh(): void;
    protected m4(a: (arg1: Axis) => void, b: string): void;
    protected m8(a: (arg1: Axis) => void, b: boolean): void;
    protected m6(a: (arg1: TitleSettings) => void): void;
    protected na(a: (arg1: TitleSettings) => void): void;
    protected m9(a: (arg1: AxisLabelSettings) => void): void;
    protected m5(a: (arg1: AxisLabelSettings) => void): void;
    protected gd(a: XamDataChart): void;
    private static s5;
    private tl;
    private um();
    private vw(a, b);
    private vj();
    private vk(a);
    private vo(a);
    private vr(a);
    private vp(a);
    private vq(a, b);
    private vs(a);
    private sz(a, b);
    protected f7(a: (arg1: Series, arg2: number) => void): void;
    private qv;
    private volumeChart;
    private wg();
    private ra(a);
    private re(a);
    private rb(a);
    private rd(a);
    private wf();
    private qs(indicatorName_);
    private qu(a);
    private wx(a);
    di(): any;
    tq(): string;
    private qt(overlayName_);
    private ww();
    private rj;
    private wu();
    protected ga(): void;
    protected get_bt(): boolean;
    protected readonly rn: boolean;
    private w2(a, b);
    private wh();
    protected gw(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private vu(a, b);
    private wq(a, b, c);
    private readonly rm;
    private vv(a, b);
    private rf(a, b);
    private wk();
    private vz(a, b);
    private v4(a, b);
    private v3(a, b);
    private vx(a, b);
    private vy(a, b);
    private v8(a, b);
    private wb(a);
    private v9(a);
    private vl();
    private wo(a, b);
    private w0(a, b);
    private v0(a, b);
    private wy();
    private ri;
    private v7(a, b);
    private vt(a, b);
    private ws(a, b, c, d);
    private wr(a);
    private wj(a);
    private v1(a, b);
    private wz();
    private wt();
    protected hm(a: Series, b: Series, c: DataSeries): void;
    protected mz(a: Axis): void;
    protected m1(a: Axis): void;
    private wa(a);
    protected gi(a: Series, b: number): void;
    protected gz(a: string, b: any, c: any): void;
    private q5;
    rl: boolean;
    private sy;
    s6: number;
    private r5;
    si: number;
    private r7;
    sk: number;
    private r6;
    sj: number;
    private r8;
    sl: number;
    readonly sh: number;
    readonly sg: number;
    private pn;
    pp: FinancialChartVolumeType;
    private pq;
    pr: FinancialChartXAxisMode;
    private ps;
    pt: FinancialChartYAxisMode;
    private q2;
    rg: boolean;
    private pj;
    pk: FinancialChartType;
    protected get_ng(): HorizontalAlignment;
    protected set_ng(a: HorizontalAlignment): void;
    private q3;
    rh: boolean;
    private px;
    py: FinancialIndicatorTypeCollection;
    private pz;
    p0: FinancialOverlayTypeCollection;
    private rp;
    private indicatorCharts;
    private q4;
    rk: boolean;
    protected get_ct(): number;
    protected set_ct(a: number): void;
    protected get_ic(): AxisLabelsLocation;
    protected set_ic(a: AxisLabelsLocation): void;
    private qw;
    zoomSliderChart: XamDataChart;
    private qh;
    private zoomSliderAxis;
    private o2;
    private zoomSliderXAxis;
    private pu;
    pw: FinancialChartZoomSliderType;
    private ol;
    ot: BrushCollection;
    private om;
    ou: BrushCollection;
    private on;
    ov: BrushCollection;
    private oo;
    ow: BrushCollection;
    private oq;
    oy: BrushCollection;
    private op;
    ox: BrushCollection;
    private ok;
    os: BrushCollection;
    private oj;
    or: BrushCollection;
    private r4;
    sf: number;
    private r2;
    sd: number;
    private r1;
    sc: number;
    private p9;
    qa: IndicatorDisplayTypeCollection;
    private su;
    s1: number;
    private r0;
    sb: number;
    private sx;
    s4: number;
    private sv;
    s2: number;
    private st;
    s0: number;
    private sw;
    s3: number;
    private pe;
    pg: FinancialChartRangeSelectorOptionCollection;
    pf: FinancialChartRangeSelectorOptionCollection;
    private pa;
    customIndicatorNames: CustomIndicatorNameCollection;
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_bu(): boolean;
    protected set_bu(a: boolean): void;
    private w4;
    w5: Brush;
    private r9;
    sm: number;
    private q1;
    rc: boolean;
    private p1;
    p2: IChartLegend;
    private o1;
    private xAxis;
    private qg;
    private yAxis;
    private qf;
    private volumeAxis;
    private o0;
    private volumeXAxis;
    private qe;
    private indicatorAxis;
    private oz;
    private indicatorXAxis;
    private ro;
    private rr;
    private rq;
    private rt;
    private rx;
    rz: Date;
    private rw;
    ry: Date;
    private ru;
    readonly xAxisBreaks: ObservableCollection$1<any>;
}
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    static $t: Type;
    bg(a: DomWrapper): void;
    bl(a: Event): void;
    private o;
    constructor(a: FinancialChart, b: any);
    private r;
    s: FinancialChartRangeSelector;
    private z;
    aa: FinancialChartTypePicker;
    private p;
    q: FinancialChartIndicatorMenu;
    private bm(a, b, c);
    private bh(a, b);
    private bi(a, b);
    private bj(a, b);
    w: FinancialChartToolbarViewModel;
    v(): FinancialChartToolbarContext;
    l(a: any): void;
    private bk();
    private aq;
    au: Date;
    private ap;
    at: Date;
    private ao;
    as: Date;
    private an;
    ar: Date;
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bn(): void;
    private x;
    y: FinancialChartType;
    private ah;
    ai: TrendLineType;
    private ab;
    ac: FinancialChartVolumeType;
    private ad;
    ae: FinancialIndicatorTypeCollection;
    private af;
    ag: FinancialOverlayTypeCollection;
    static am(a: IList, b: IList): boolean;
    aj(): FinancialChartToolbarVisualData;
    private t;
    u: FinancialChartRangeSelectorOptionCollection;
    private ak;
    al: boolean;
}
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    static $t: Type;
    private static x;
    q: FinancialChartRangeSelectorViewModel;
    v: Date;
    u: Date;
    t: Date;
    s: Date;
    ab(): void;
    constructor(a: any);
    l(a: any): void;
    private z();
    rangeChanged: (sender: any, e: EventArgs) => void;
    r(): FinancialChartRangeSelectorVisualData;
    o: FinancialChartRangeSelectorOptionCollection;
    private aa();
    private p;
}
