/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core/ES5/type";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { DataSeriesType_$type } from "igniteui-angular-core/ES5/DataSeriesType";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core/ES5/IDataSeriesAdapterRule";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core/ES5/SimpleFinancialPriceSeriesRule";
import { SubCollectionsRule } from "igniteui-angular-core/ES5/SubCollectionsRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core/ES5/ArrayExtension";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
import { timeSpanFromDays } from "igniteui-angular-core/ES5/timespan";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core/ES5/date";
import { isNaN_, isInfinity } from "igniteui-angular-core/ES5/number";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
var FinancialChart = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.qb = null;
        _this.ss = null;
        _this.sq = null;
        _this.sn = null;
        _this.sp = null;
        _this.sr = null;
        _this.so = null;
        _this.ph = null;
        _this.ta = null;
        _this.tb = null;
        _this.s7 = null;
        _this.tc = null;
        _this.td = null;
        _this.s8 = null;
        _this.s9 = null;
        _this.qz = null;
        _this.r3 = 40;
        _this.p5 = null;
        _this.p3 = null;
        _this.p7 = null;
        _this.qc = null;
        _this.tl = null;
        _this.qv = null;
        _this.rj = false;
        _this.ri = false;
        _this.q5 = false;
        _this.sy = 10;
        _this.r5 = NaN;
        _this.r7 = NaN;
        _this.r6 = NaN;
        _this.r8 = 0;
        _this.pn = 0;
        _this.pq = 0;
        _this.ps = 0;
        _this.q2 = true;
        _this.pj = 0;
        _this.q3 = false;
        _this.px = null;
        _this.pz = null;
        _this.rp = null;
        _this.q4 = true;
        _this.qw = null;
        _this.pu = 1;
        _this.ol = null;
        _this.om = null;
        _this.on = null;
        _this.oo = null;
        _this.oq = null;
        _this.op = null;
        _this.ok = null;
        _this.oj = null;
        _this.r4 = 1;
        _this.r2 = 1;
        _this.r1 = 1;
        _this.p9 = null;
        _this.su = -2147483648;
        _this.r0 = 2;
        _this.sx = 3;
        _this.sv = 10;
        _this.st = 30;
        _this.sw = 9;
        _this.pe = null;
        _this.pf = null;
        _this.pa = null;
        _this.applyCustomIndicators = null;
        _this.w4 = null;
        _this.r9 = 1;
        _this.q1 = false;
        _this.p1 = null;
        _this.rx = dateMinValue();
        _this.rw = dateMaxValue();
        _this.ru = null;
        _this.f4();
        _this.ru = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.wt(); });
        }
        _this.we();
        return _this;
    }
    FinancialChart.prototype.g1 = function (a, b, c) {
        _super.prototype.g1.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.pi = new FinancialChartToolbar(this, this.ti);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.v2));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.v5));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.v6));
                    d.l(null);
                }
                if (this.pi != null) {
                    this.pi.ac = this.pp;
                    this.pi.ai = this.av;
                    this.pi.y = this.pk;
                    this.pi.al = this.rg;
                    if (this.sp != null) {
                        this.pi.l(this.sp);
                    }
                    var e = this.pi;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.v2));
                    ;
                    var f = this.pi;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.v5));
                    var g = this.pi;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.v6));
                }
                break;
            case "ChartType":
                if (this.pi != null) {
                    this.pi.y = this.pk;
                }
                break;
            case "VolumeType":
                if (this.pi != null) {
                    this.pi.ac = this.pp;
                }
                break;
            case "TrendLineType":
                if (this.pi != null) {
                    this.pi.ai = this.av;
                }
                break;
            case "IsToolbarVisible":
                if (this.pi == null) {
                    break;
                }
                this.pi.al = this.rg;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.v6 = function (a, b) {
        this.pp = this.pi.ac;
    };
    FinancialChart.prototype.v5 = function (a, b) {
        this.av = this.pi.ai;
    };
    FinancialChart.prototype.v2 = function (a, b) {
        this.pk = this.pi.y;
    };
    FinancialChart.prototype.we = function () {
        this.qb = new IndicatorPane();
        this.p2 = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.ss = a;
        this.wz();
        this.setGridRows();
        if (this.pi != null) {
            this.pi.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.pi != null) {
            this.pi.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.pi.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.dh;
        b.toolbarContainer = this.sp;
        b.legendContainer = this.so;
        b.indicatorsContainer = this.sn;
        b.volumeContainer = this.sq;
        b.zoomContainer = this.sr;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.pi == null) {
                this.pi = new FinancialChartToolbar(this, this.ti);
            }
            this.pi.w.isIndicatorMenuVisible = this.q7 && this.q8;
            this.sp = b.getSubRenderer(d);
            this.pi.l(this.sp);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.so = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.sn = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.sq = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.sr = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.sp = null;
            if (this.pi != null) {
                this.pi.l(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (this.volumeChart != null) {
            this.volumeChart.provideContainer(this.sq);
        }
        if (this.qb != null) {
            this.qb.h(this.sn);
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.provideContainer(this.sr);
            if (a != null) {
                this.vn();
            }
            else {
                this.q0 = null;
            }
        }
        if (this.p2 != null) {
            this.p2.provideContainer(this.so);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.wp = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.w3 = function (a, b) {
        this.wp(a, b, this.sr);
        if (b == null) {
            return;
        }
        this.vn();
    };
    FinancialChart.prototype.vn = function () {
        var _this = this;
        if (this.sr == null) {
            return;
        }
        if (this.q0 != null) {
            this.q0.provideContainer(null);
        }
        this.q0 = TypeRegistrar.create("ZoomSlider");
        this.q0.provideContainer(this.sr);
        var a = this.q0;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.m1 = new Rect(0, _this.q0.windowRect.left, _this.dataChart.mn.top, _this.q0.windowRect.width, _this.dataChart.mn.height);
            }
        });
    };
    FinancialChart.prototype.w1 = function (a, b) {
        this.wp(a, b, this.sq);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.ss == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.rg ? this.se : 0) + "px";
        a[1] = this.rc ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.q0 != null) {
            if (a[5] == "0px") {
                this.q0.hide();
            }
            else {
                this.q0.show();
            }
        }
        this.ss.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, tslib_1.__spread([" "], a)), "auto", "1fr"));
        this.ss.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, tslib_1.__spread([" "], a)));
        if (this.dh == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.qb != null) {
            this.qb.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.q0 != null) {
            this.q0.notifySizeChanged();
        }
    };
    FinancialChart.prototype.gh = function () {
        _super.prototype.gh.call(this);
        this.ic = 3;
        this.ng = 0;
        this.ct = NaN;
        this.cr = 30;
        this.bo = true;
        this.bu = false;
        if (this.dataChart != null) {
            var a = this.dataChart.bm.i.e();
            this.ot = a.d;
            this.ou = a.e;
            this.os = a.d;
            this.w5 = this.dataChart.pj;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.ov = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.ow = c;
    };
    FinancialChart.prototype.wl = function () {
        if (this.qb != null) {
            this.qb.b = null;
            this.qb.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.wm = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.wv = function () {
        this.wl();
    };
    FinancialChart.prototype.vm = function () {
        if (this.q0 == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.dh.rootWrapper.width();
        var b = this.dataChart.m0.left + this.dataChart.m0.width;
        var c = this.dataChart.m0.left;
        var d = a - b;
        this.q0.startInset = c - this.q0.trackStartInset;
        this.q0.endInset = d - this.q0.trackEndInset;
        if (this.q0.endInset < 0) {
            var e = this.q0.endInset;
            this.q0.endInset = 0;
            this.dataChart.ek += (e * -1);
        }
        if (this.q0.startInset < 0) {
            var f = this.q0.startInset;
            this.q0.startInset = 0;
            this.dataChart.ei += (f * -1);
        }
        this.zoomSliderChart.ei = c;
        this.zoomSliderChart.ek = d;
        this.zoomSliderChart.ee = this.q0.barExtent;
    };
    FinancialChart.prototype.wc = function () {
        this.vm();
    };
    FinancialChart.prototype.ge = function (a) {
        _super.prototype.ge.call(this, a);
        if (a != null) {
            a.ed = 0;
        }
    };
    FinancialChart.prototype.w6 = function (a) {
        return a.mg();
    };
    FinancialChart.prototype.w9 = function () {
        return this.so == null ? null : this.w8(this.so.rootWrapper);
    };
    FinancialChart.prototype.w7 = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.w8(a.d.rootWrapper);
    };
    FinancialChart.prototype.w8 = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.sa = function () {
        if (this.ss == null) {
            return NaN;
        }
        var a = this.ss.getOffset();
        return this.ss.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.gp = function (source_, a, b) {
        _super.prototype.gp.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hw(source_, a, b);
        }
    };
    FinancialChart.prototype.gq = function (source_, a, b) {
        _super.prototype.gq.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hx(source_, a, b);
        }
    };
    FinancialChart.prototype.go = function (source_) {
        _super.prototype.go.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ht(source_);
        }
    };
    FinancialChart.prototype.gs = function (source_, a, b, c) {
        _super.prototype.gs.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hy(source_, a, b, c);
        }
    };
    FinancialChart.prototype.gk = function (a, b) {
        _super.prototype.gk.call(this, a, b);
        if (this.rd(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "pi", {
        get: function () {
            return this.ph;
        },
        set: function (a) {
            var b = this.pi;
            if (a != b) {
                this.ph = a;
                this.gz("Toolbar", b, this.pi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "th", {
        get: function () {
            return this.ta;
        },
        set: function (a) {
            var b = this.th;
            if (a != b) {
                this.ta = a;
                this.gz("RangeSelectorTemplate", b, this.th);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ti", {
        get: function () {
            return this.tb;
        },
        set: function (a) {
            var b = this.ti;
            if (a != b) {
                this.tb = a;
                this.gz("ToolbarTemplate", b, this.ti);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "te", {
        get: function () {
            return this.s7;
        },
        set: function (a) {
            var b = this.te;
            if (a != b) {
                this.s7 = a;
                this.gz("ChartTypePickerTemplate", b, this.te);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tj", {
        get: function () {
            return this.tc;
        },
        set: function (a) {
            var b = this.tj;
            if (a != b) {
                this.tc = a;
                this.gz("TrendLineTypePickerTemplate", b, this.tj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tk", {
        get: function () {
            return this.td;
        },
        set: function (a) {
            var b = this.tk;
            if (a != b) {
                this.td = a;
                this.gz("VolumeTypePickerTemplate", b, this.tk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tf", {
        get: function () {
            return this.s8;
        },
        set: function (a) {
            var b = this.tf;
            if (a != b) {
                this.s8 = a;
                this.gz("IndicatorMenuTemplate", b, this.tf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tg", {
        get: function () {
            return this.s9;
        },
        set: function (a) {
            var b = this.tg;
            if (a != b) {
                this.s9 = a;
                this.gz("OverlayPickerTemplate", b, this.tg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q0", {
        get: function () {
            return this.qz;
        },
        set: function (a) {
            var b = this.q0;
            if (a != b) {
                this.qz = a;
                this.gz("ZoomSlider", b, this.q0);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cr = function () {
        return _super.prototype.get_cr.call(this);
    };
    FinancialChart.prototype.set_cr = function (a) {
        _super.prototype.set_cr.call(this, a);
    };
    FinancialChart.prototype.get_bo = function () {
        return _super.prototype.get_bo.call(this);
    };
    FinancialChart.prototype.set_bo = function (a) {
        _super.prototype.set_bo.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "se", {
        get: function () {
            return this.r3;
        },
        set: function (a) {
            var b = this.se;
            if (a != b) {
                this.r3 = a;
                this.gz("ToolbarHeight", b, this.se);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.h5 = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.h6 = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.u = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_b3 = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b3", {
        get: function () {
            return this.get_b3();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_b2 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b2", {
        get: function () {
            return this.get_b2();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.o4 = function (a) {
        return this.o5(a);
    };
    FinancialChart.prototype.qi = function (a) {
        return this.qj(a);
    };
    FinancialChart.prototype.o3 = function (a) {
        var b = this.o4(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.f2 = function () {
        this.xAxis = this.o3("xAxis");
        this.yAxis = this.qi(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.qi(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.o3("volumeXAxis");
        this.rr = new List$1(NumericYAxis.$, 0);
        this.rt = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.qi(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.o3("indicatorXAxis_0");
        this.rr.add(this.indicatorAxis);
        this.rt.add(this.indicatorXAxis);
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeXAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorAxis.aw == null) {
            this.indicatorAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.aw == null) {
            this.indicatorXAxis.aw = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.qi(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.o3("zoomSliderXAxis");
        if (this.zoomSliderAxis.aw == null) {
            this.zoomSliderAxis.aw = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.aw == null) {
            this.zoomSliderXAxis.aw = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.f0 = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.ls = this.ai(a, b);
        }
    };
    FinancialChart.prototype.hf = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jm = true;
            this.yAxis.j9 = 10;
        }
    };
    FinancialChart.prototype.hi = function () {
        this.yAxis.jm = this.rl;
        this.yAxis.j9 = this.s6;
    };
    FinancialChart.prototype.pm = function (a) {
        var b;
        if (this.pk == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.pk;
        }
        b = this.pl(b);
        return b;
    };
    FinancialChart.prototype.pl = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.pv = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.po = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ts = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.o5 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qj = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qp = function () {
        return this.ar(1);
    };
    FinancialChart.prototype.qq = function () {
        return this.ar(0);
    };
    FinancialChart.prototype.qo = function () {
        return this.ar(2);
    };
    FinancialChart.prototype.qr = function () {
        return this.ar(20);
    };
    Object.defineProperty(FinancialChart.prototype, "q6", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p6", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q9", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p4", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q7", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p8", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q8", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qd", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.aq = function (a, b) {
        var c = this.ts(a);
        switch (this.pm(a)) {
            case 3:
                var d = this.qp();
                this.p6.setValueMemberPath(d, c);
                this.p6.setXAxis(d, this.xAxis);
                this.p6.setYAxis(d, this.yAxis);
                this.p6.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.qq();
                this.p6.setValueMemberPath(e, c);
                this.p6.setXAxis(e, this.xAxis);
                this.p6.setYAxis(e, this.yAxis);
                this.p6.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.qr();
                this.p4.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.p4.setHighMemberPath(f, a.getMemberPathFor(12));
                this.p4.setLowMemberPath(f, a.getMemberPathFor(13));
                this.p4.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.p4.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.p4.setXAxis(f, this.xAxis);
                this.p4.setYAxis(f, this.yAxis);
                this.p4.setDisplayType(f, this.pk == 1 ? 1 : 0);
                this.p4.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.hh = function () {
        _super.prototype.hh.call(this);
        this.wa(this.xAxis);
        this.wx(false);
        if (this.pp != 0 && this.volumeChart != null) {
            this.wg();
        }
        this.wa(this.volumeXAxis);
        this.wa(this.indicatorXAxis);
        this.wu();
        this.ww();
        if (this.pw != 0) {
            this.wh();
            this.wa(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.m4 = function (a, b) {
        _super.prototype.m4.call(this, a, b);
        a(this.volumeXAxis);
        if (this.rt != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.rt)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    a(c);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
        var e_1, _c;
    };
    FinancialChart.prototype.m8 = function (a, b) {
        _super.prototype.m8.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.rr != null) {
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.rr)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var c = _b.value;
                        a(c);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            a(this.zoomSliderAxis);
        }
        var e_2, _c;
    };
    FinancialChart.prototype.m6 = function (a) {
        _super.prototype.m6.call(this, a);
        this.my(this.volumeXAxis, a);
        this.my(this.indicatorXAxis, a);
        this.my(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.na = function (a) {
        _super.prototype.na.call(this, a);
        this.my(this.volumeAxis, a);
        this.my(this.indicatorAxis, a);
        this.my(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.m9 = function (a) {
        _super.prototype.m9.call(this, a);
        this.mx(this.volumeAxis, a);
        this.mx(this.indicatorAxis, a);
        this.mx(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.m5 = function (a) {
        _super.prototype.m5.call(this, a);
        this.mx(this.volumeXAxis, a);
        this.mx(this.indicatorXAxis, a);
        this.mx(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.gd = function (a) {
        var _this = this;
        _super.prototype.gd.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.no = a.nq = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.m6 = this.dataChart.m6;
                a.m9 = this.dataChart.m9;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.ae = _this.um();
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    };
    FinancialChart.prototype.um = function () {
        if (this.tl == null) {
            FinancialChart.s5++;
            this.tl = FinancialChart.s5.toString();
        }
        return this.tl;
    };
    FinancialChart.prototype.vw = function (a, b) {
        this.vj();
        this.wc();
    };
    FinancialChart.prototype.vj = function () {
        if (this.yAxis.bz()) {
            return;
        }
        var a = this.yAxis.at.a5;
        if (this.pp != 0) {
            a = Math.max(a, this.volumeAxis.at.a5);
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(this.rr)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a = Math.max(a, b.at.a5);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.vk(a);
        var e_3, _c;
    };
    FinancialChart.prototype.vk = function (a) {
        if (this.yAxis.bz()) {
            return;
        }
        this.yAxis.d1 = this.volumeAxis.d1 = a;
        try {
            for (var _a = tslib_1.__values(fromEnum(this.rr)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                b.d1 = a;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.zoomSliderAxis.d1 = this.yAxis.d1;
        var e_4, _c;
    };
    FinancialChart.prototype.vo = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.vr = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.vp = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.rd(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.vq = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rd(d)) {
                continue;
            }
            var e = this.sz(d, c);
            a(d, e);
        }
        if (b) {
            this.vs(a);
        }
    };
    FinancialChart.prototype.vs = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.sz = function (a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        var c = this.v == null || this.v.dataSeries == null ? 0 : this.v.dataSeries.count;
        var d = this.p0 == null ? 0 : this.p0.count;
        return b - (c * d);
    };
    FinancialChart.prototype.f7 = function (a) {
        _super.prototype.f7.call(this, a);
        this.vr(a);
        this.vo(a);
        this.vs(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.qv;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.qv = a;
                this.gz("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.wg = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rd(d)) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.pp;
            f = this.po(f);
            switch (f) {
                case 2:
                    e = this.qq();
                    break;
                case 3:
                    e = this.qo();
                    break;
                default:
                case 1:
                    e = this.qp();
                    break;
            }
            this.p6.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.p6.setXAxis(e, this.volumeXAxis);
            this.p6.setYAxis(e, this.volumeAxis);
            this.p6.setValueMemberPath(e, this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > b ? this.v.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fr = d.fr + " Volume";
            e.kw = ArrayExtension.getModulus$1(Brush.$, this.ox, b);
            e.kz = ArrayExtension.getModulus$1(Brush.$, this.oy, b);
            e.eu = this.sf;
            a.add(e);
        }
        var g = this.bz("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.gi(i, h);
        }
    };
    FinancialChart.prototype.ra = function (a) {
        if (!this.q6) {
            return false;
        }
        return this.p6.matchesType(a);
    };
    FinancialChart.prototype.re = function (a) {
        if (!this.q9) {
            return false;
        }
        return this.p4.matchesType(a);
    };
    FinancialChart.prototype.rb = function (a) {
        if (!this.q7) {
            return false;
        }
        return this.p8.matchesType(a);
    };
    FinancialChart.prototype.rd = function (a) {
        if (!this.q8) {
            return false;
        }
        return this.qd.matchesType(a);
    };
    FinancialChart.prototype.wf = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.py == null ? 0 : this.py.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.py._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.rd(l) || l.cj) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.qs("Custom");
                    this.p8.handleCustomIndicatorEvent(n, runOn(this, this.vu));
                    m = n;
                }
                else {
                    m = this.qu(this.py._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.p8.setXAxis(m, this.rt._inner[e]);
                this.p8.setYAxis(m, this.rr._inner[e]);
                m.itemsSource = l.itemsSource;
                this.p8.setOpenMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(11));
                this.p8.setHighMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(12));
                this.p8.setLowMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(13));
                this.p8.setCloseMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(14));
                this.p8.setVolumeMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(15));
                m.fr = l.fr + " " + i;
                m.kw = ArrayExtension.getModulus$1(Brush.$, this.or, e);
                m.eu = this.sc;
                if (this.rb(m)) {
                    this.p8.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.os, e));
                    this.p8.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.qa, e));
                }
                if (this.s1 != -2147483648 && this.rb(m)) {
                    this.p8.setPeriodOverride(m, this.s1);
                }
                if (this.rb(m)) {
                    this.p8.setSmoothingPeriod(m, this.s4);
                }
                if (this.rb(m)) {
                    this.p8.setSignalPeriod(m, this.s3);
                }
                if (this.rb(m)) {
                    this.p8.setShortPeriod(m, this.s2);
                    this.p8.setLongPeriod(m, this.s0);
                }
                this.gi(m, e);
                f.add(m);
            }
            var o = this.bz(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.gi(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.qs = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.qu = function (a) {
        return this.qs(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.wx = function (a) {
        if (this.pi == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.pi.as = b.actualMinimumValue;
        this.pi.ar = b.actualMaximumValue;
        if (a) {
            this.pi.au = b.visibleMinimum;
            this.pi.at = b.visibleMaximum;
        }
        this.pi.bn();
    };
    FinancialChart.prototype.di = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.di.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.ob();
            $ret.toolbar = _this.pi == null ? null : _this.pi.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.ob();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    a.indicatorCharts.add1(b.ob());
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.w6(this.dataChart).x;
            a.mainChartTop = this.w6(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.w6(this.volumeChart).x;
            a.volumeChartTop = this.w6(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.w6(this.zoomSliderChart).x;
            a.zoomChartTop = this.w6(this.zoomSliderChart).y;
        }
        if (this.pi != null) {
            var c = this.w7(this.pi);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _d = tslib_1.__values(fromEnum(this.indicatorCharts)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var d = _e.value;
                    a.indicatorChartLefts.add(this.w6(d).x);
                    a.indicatorChartTops.add(this.w6(d).y);
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        var e = this.w9();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.p2 == null ? null : this.p2.exportVisualData();
        return a;
        var e_5, _c, e_6, _f;
    };
    FinancialChart.prototype.tq = function () {
        var a = this.di();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.qt = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.ww = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.dataChart.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                if (this.rd(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_7) throw e_7.error; }
        }
        try {
            for (var _d = tslib_1.__values(fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_8) throw e_8.error; }
        }
        if (this.p0 == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.rd(g) || g.cj) {
                continue;
            }
            e++;
            for (var h = 0; h < this.p0.count; h++) {
                var i = this.p0._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.qt(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.qt(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.qd.setXAxis(j, this.xAxis);
                this.qd.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.p0.count + h;
                j.kw = ArrayExtension.getModulus$1(Brush.$, this.ov, k);
                j.kz = ArrayExtension.getModulus$1(Brush.$, this.ow, k);
                j.eu = this.sd;
                j.fr = g.fr + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.v.dataSeries._inner[e];
                this.qd.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.qd.setHighMemberPath(j, m.getMemberPathFor(12));
                this.qd.setLowMemberPath(j, m.getMemberPathFor(13));
                this.qd.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.qd.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].fd = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.gi(q, p);
        }
        var e_7, _c, e_8, _f;
    };
    FinancialChart.prototype.wu = function () {
        if (this.rj) {
            return;
        }
        this.rj = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    this.wb(b);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
        if ((this.py == null || this.py.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.rr != null) {
                this.rr.clear();
            }
            if (this.rt != null) {
                this.rt.clear();
            }
            this.wl();
            this.wv();
            this.rj = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.rr.clear();
        this.rt.clear();
        var c = this.py == null ? 0 : this.py.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.v9(g);
            var h = f >= c;
            g.go = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.py._inner[f]);
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b5) {
                        j = this.o4(0);
                    }
                    else {
                        j = this.o4(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.rr.add(i);
                this.rt.add(j);
                if (this.bf) {
                    this.m1(i);
                }
                if (this.bf) {
                    this.mz(j);
                }
            }
        }
        this.wf();
        this.wl();
        if (this.pi != null) {
            this.pi.ae = this.py;
        }
        this.vl();
        this.wv();
        this.rj = false;
        var e_9, _c;
    };
    FinancialChart.prototype.ga = function () {
        _super.prototype.ga.call(this);
        this.mz(this.xAxis);
        this.mz(this.volumeXAxis);
        if (this.rt != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.rt)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var a = _b.value;
                    this.mz(a);
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_10) throw e_10.error; }
            }
        }
        this.m1(this.yAxis);
        this.m1(this.volumeAxis);
        if (this.rr != null) {
            try {
                for (var _d = tslib_1.__values(fromEnum(this.rr)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var b = _e.value;
                    this.m1(b);
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        this.mz(this.zoomSliderXAxis);
        this.m1(this.zoomSliderAxis);
        var e_10, _c, e_11, _f;
    };
    FinancialChart.prototype.get_bt = function () {
        return !this.rh;
    };
    Object.defineProperty(FinancialChart.prototype, "rn", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.w2 = function (a, b) {
        this.wo(a, b);
        this.vl();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.wh();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.wm();
        this.w3(a, b);
    };
    FinancialChart.prototype.wh = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.rd(c) || c.cj) {
                continue;
            }
            var d = void 0;
            var e = this.pw;
            e = this.pv(e);
            var f = this.sz(c, b);
            if (e == 1) {
                switch (this.pm(this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.qr();
                    this.p4.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.qr();
                    this.p4.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.qq();
                    break;
                case 6:
                    d = this.qo();
                    break;
                default:
                case 4:
                    d = this.qp();
                    break;
            }
            var g = this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null;
            if (d.cl && !d.cr) {
                this.p6.setCategoryMode(d, 1);
                this.p6.setXAxis(d, this.zoomSliderXAxis);
                this.p6.setYAxis(d, this.zoomSliderAxis);
                this.p6.setValueMemberPath(d, g == null ? null : this.ts(g));
            }
            else if (d.cr) {
                this.p4.setCategoryMode(d, 1);
                this.p4.setXAxis(d, this.zoomSliderXAxis);
                this.p4.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.p4.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.p4.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.p4.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.p4.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.p4.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.fr = c.fr;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.gi(i, h);
        }
    };
    FinancialChart.prototype.gw = function (a, b, c) {
        _super.prototype.gw.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var f = _b.value;
                    a(f);
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
        var e_12, _c;
    };
    FinancialChart.prototype.vu = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.py == null ? 0 : this.py.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.wq = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bf) {
            this.mz(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rm", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.vv = function (a, b) {
        this.wu();
    };
    FinancialChart.prototype.rf = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.wk = function () {
        var a = this.pg != null ? this.pg : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var e = _b.value;
                if (this.rf(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_13) throw e_13.error; }
        }
        this.pf = b;
        if (this.pi != null) {
            this.pi.u = this.pf;
        }
        var e_13, _c;
    };
    FinancialChart.prototype.vz = function (a, b) {
        this.wk();
    };
    FinancialChart.prototype.v4 = function (a, b) {
        this.p0 = this.pi.ag;
    };
    FinancialChart.prototype.v3 = function (a, b) {
        this.py = this.pi.ae;
    };
    FinancialChart.prototype.vx = function (a, b) {
        this.wu();
    };
    FinancialChart.prototype.vy = function (a, b) {
        this.ww();
    };
    FinancialChart.prototype.v8 = function (a, b) {
        var c = a;
        if (c.bd == null) {
            return;
        }
        if (this.rh) {
            this.wj(c.bd);
        }
    };
    FinancialChart.prototype.wb = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.vw));
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d1 = this.volumeAxis.d1 = this.indicatorAxis.d1 = 0;
            this.xAxis.aw.visibility = this.oh;
        }
    };
    FinancialChart.prototype.v9 = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.m1 = new Rect(0, this.dataChart.mn.x, a.m1.y, this.dataChart.mn.width, a.m1.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.ae = "one";
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.vw));
        this.gc(a);
    };
    FinancialChart.prototype.vl = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.mx(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.rt._inner[a];
            var c = a < this_1.rt.count - 1 || this_1.volumeChart != null;
            this_1.mx(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.rt.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.wo = function (a, b) {
        if (a != null) {
            this.wb(a);
        }
        if (b != null) {
            this.v9(b);
        }
    };
    FinancialChart.prototype.w0 = function (a, b) {
        this.wo(a, b);
        this.vl();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.wg();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.w1(a, b);
    };
    FinancialChart.prototype.v0 = function (a, b) {
        this.wy();
    };
    FinancialChart.prototype.wy = function () {
        if (this.pi == null || +(this.pi.au) == +(dateMaxValue()) || +(this.pi.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.pi.au, this.pi.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.ri = true;
        this.dataChart.m1 = new Rect(0, b.left, this.dataChart.m1.top, b.width, this.dataChart.m1.height);
        if (this.q0 != null) {
            this.q0.windowRect = this.dataChart.mn;
        }
        if (this.rh) {
            this.wj(this.dataChart);
        }
        this.ri = false;
    };
    FinancialChart.prototype.v7 = function (a, b) {
        this.wk();
        this.wx(!this.ri);
    };
    FinancialChart.prototype.vt = function (a, b) {
        var _this = this;
        if (!this.ri) {
            if (this.rh) {
                this.wj(a);
            }
            var c = false;
            var d = this.g4(function () { return _this.wx(true); }, c);
            c = d.p1;
            if (this.q0 != null) {
                this.q0.windowRect = this.dataChart.mn;
            }
        }
    };
    FinancialChart.prototype.ws = function (a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.ri = true;
            a.m1 = new Rect(0, d, a.mn.top, c, a.mn.height);
            this.ri = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.b8, a.mr);
        try {
            for (var _a = tslib_1.__values(fromEnum(a.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var i = _b.value;
                h.b = i.ed();
                var j = i.ao();
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dt(j.c, h);
                var m = b.dt(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_14) throw e_14.error; }
        }
        var n = a.mn.width;
        if (c != -1) {
            n = c;
        }
        var o = a.mn.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.ri = true;
        var p = new Rect(0, o, e, n, f - e);
        a.m1 = p;
        this.ri = false;
        var e_14, _c;
    };
    FinancialChart.prototype.wr = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.ws(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.ws(this.volumeChart, this.volumeAxis, this.dataChart.mn.width, this.dataChart.mn.left);
            }
        }
        else if (a == this.volumeChart) {
            this.ws(this.volumeChart, this.volumeAxis, -1, -1);
            this.ws(this.dataChart, this.yAxis, this.volumeChart.mn.width, this.volumeChart.mn.left);
        }
    };
    FinancialChart.prototype.wj = function (a) {
        var _this = this;
        this.g3(function () { return _this.wr(a); });
    };
    FinancialChart.prototype.v1 = function (a, b) {
        if (this.rh) {
            this.wj(a);
        }
    };
    FinancialChart.prototype.wz = function () {
        if (!this.rn) {
            return;
        }
        if (this.pw == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.wh();
        }
    };
    FinancialChart.prototype.wt = function () {
        var _this = this;
        if (this.pr != 1) {
            return;
        }
        this.m3(function (a) {
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _a = tslib_1.__values(fromEnum(_this.xAxisBreaks)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    b.add(c);
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_15) throw e_15.error; }
            }
            var e_15, _c;
        });
    };
    FinancialChart.prototype.hm = function (a, b, c) {
        _super.prototype.hm.call(this, a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (this.pr == 1 && stringIsNullOrEmpty(this.d9)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.eb)) {
                this.ac.setYMemberPath(a, this.ts(c));
            }
            if (stringIsNullOrEmpty(this.d5)) {
                this.ac.setLabelMemberPath(a, this.ts(c));
            }
            if (stringIsNullOrEmpty(this.d2)) {
                this.ac.setContentMemberPath(a, this.ts(c));
            }
        }
    };
    FinancialChart.prototype.mz = function (a) {
        _super.prototype.mz.call(this, a);
        var b = a;
        this.wa(b);
        if (a.bd != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.bd.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    if (this.ra(c)) {
                        this.p6.setXAxis(c, b);
                    }
                    else if (this.re(c)) {
                        this.p4.setXAxis(c, b);
                    }
                    else if (this.rb(c)) {
                        this.p8.setXAxis(c, b);
                    }
                    else if (this.rd(c)) {
                        this.qd.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_16) throw e_16.error; }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.ic = this.w5;
            a.d0 = this.sm;
            this.mx(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.rz;
        e.maximumValue = this.ry;
        var e_16, _c;
    };
    FinancialChart.prototype.m1 = function (a) {
        _super.prototype.m1.call(this, a);
        if (a.bd != null && a == this.yAxis) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.bd.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    if (this.ra(b)) {
                        this.p6.setYAxis(b, this.yAxis);
                    }
                    else if (this.re(b)) {
                        this.p4.setYAxis(b, this.yAxis);
                    }
                    else if (this.rb(b)) {
                        this.p8.setYAxis(b, this.yAxis);
                    }
                    else if (this.rd(b)) {
                        this.qd.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) { e_17 = { error: e_17_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_17) throw e_17.error; }
            }
        }
        a.jh = this.rk;
        a.j5 = this.sk;
        a.j4 = this.sj;
        if (a == this.yAxis) {
            a.j1 = this.si;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.mx(a, function (d) { return d.visibility = 1; });
        }
        var e_17, _c;
    };
    FinancialChart.prototype.wa = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e2 = XYChart.kt(a, this.v.dataSeries);
        if (this.v.dataSeries.count > 0) {
            var b = this.v.dataSeries._inner[0].getMemberPathFor(17);
            a.gq(b);
        }
    };
    FinancialChart.prototype.gi = function (a, b) {
        _super.prototype.gi.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cz) {
            a.i9(this.ot != null ? ArrayExtension.getModulus$1(Brush.$, this.ot, b) : null, this.ou != null ? ArrayExtension.getModulus$1(Brush.$, this.ou, b) : null);
        }
        var d = this.zoomSliderChart == a.bq;
        var e = this.rb(a);
        if (this.rd(a)) {
            a.kw = this.ov != null ? ArrayExtension.getModulus$1(Brush.$, this.ov, b) : null;
            a.kz = this.ow != null ? ArrayExtension.getModulus$1(Brush.$, this.ow, b) : null;
            a.eu = this.sd;
        }
        else if (e) {
            a.kw = this.or != null ? ArrayExtension.getModulus$1(Brush.$, this.or, b) : null;
            a.eu = this.sc;
        }
        else if (!a.cj && (c || d)) {
            a.kw = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.kz = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.bq;
        if (f) {
            a.eu = this.sf;
        }
        a.legend = d || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.rc ? this.p2 : null;
    };
    FinancialChart.prototype.gz = function (a, b, c) {
        var _this = this;
        _super.prototype.gz.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.jm = this.rl;
                if (this.volumeAxis != null) {
                    this.volumeAxis.jm = this.rl;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.jm = this.rl;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.j9 = this.s6;
                if (this.volumeAxis != null) {
                    this.volumeAxis.j9 = this.s6;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.j9 = this.s6;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.pp == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.wg();
                }
                break;
            case "VolumeChart":
                this.w0(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.vw));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.vt));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.v1));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.vw));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.vt));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.v1));
                }
                this.wz();
                break;
            case "XAxisMode":
                this.xAxis = this.o4(this.pr);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.o4(this.pr);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.o4(this.pr);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.o4(this.pr);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.mx(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.vl();
                if (this.pr == 1) {
                    this.wt();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.qi(this.pt);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.qi(this.pt);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.qi(this.pt);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.v0));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.v3));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.v4));
                }
                if (this.pi != null) {
                    this.pi.ae = this.py;
                    this.pi.ag = this.p0;
                    this.pi.u = this.pf;
                    this.wx(true);
                    var j = this.pi;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.v0));
                    var k = this.pi;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.v3));
                    var l = this.pi;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.v4));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.v7));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bf) {
                    this.mz(this.xAxis);
                    this.f5();
                }
                this.wx(false);
                this.wy();
                this.wk();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.v7));
                break;
            case "ChartType":
                this.hh();
                break;
            case "VolumeXAxis":
                this.wq(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.wq(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.wu();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bf) {
                    this.m1(this.yAxis);
                    this.m1(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.v8));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.wg();
                }
                if (this.bf) {
                    this.m1(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.v8));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _a = tslib_1.__values(fromEnum(u.axes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                var w = _b.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) { e_18 = { error: e_18_1 }; }
                        finally {
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_18) throw e_18.error; }
                        }
                        try {
                            for (var _d = tslib_1.__values(fromEnum(v)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var x = _e.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) { e_19 = { error: e_19_1 }; }
                        finally {
                            try {
                                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                            }
                            finally { if (e_19) throw e_19.error; }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.pt == 1) {
                            y = this.qi(this.pt);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bf) {
                            this.m1(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nq = this.bu && this.bt;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nq = this.bu && this.bt;
                }
                if (this.rh) {
                    this.wr(this.dataChart);
                }
                else {
                    this.volumeChart.n9 = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.vx));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.vx));
                }
                this.wu();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.vy));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.vy));
                }
                this.ww();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.m7(function (ad) { return ad.jh = _this.rk; });
                break;
            case "YAxisMinimumValue":
                this.m8(function (ad) { return ad.j5 = _this.sk; }, false);
                break;
            case "YAxisMaximumValue":
                this.m8(function (ad) { return ad.j4 = _this.sj; }, false);
                break;
            case "YAxisInterval":
                this.m8(function (ad) { return ad.j1 = _this.si; }, false);
                break;
            case "ZoomSliderType":
                this.wz();
                break;
            case "ZoomSliderChart":
                if (!this.rm) {
                    return;
                }
                this.w2(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.vq(function (ad, ae) {
                    if (ad.cz) {
                        ad.i9(_this.ot != null ? ArrayExtension.getModulus$1(Brush.$, _this.ot, ae) : null, _this.ou != null ? ArrayExtension.getModulus$1(Brush.$, _this.ou, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.f7(function (ad, ae) {
                    if (!(_this.rd(ad))) {
                        return;
                    }
                    ad.kw = _this.ov != null ? ArrayExtension.getModulus$1(Brush.$, _this.ov, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.f7(function (ad, ae) {
                    if (!(_this.rd(ad))) {
                        return;
                    }
                    ad.kz = _this.ow != null ? ArrayExtension.getModulus$1(Brush.$, _this.ow, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.f7(function (ad, ae) {
                    if (!(_this.rd(ad))) {
                        return;
                    }
                    ad.eu = _this.sd;
                });
                break;
            case "VolumeBrushes":
                this.vr(function (ad, ae) { return ad.kw = ArrayExtension.getModulus$1(Brush.$, _this.ox, ae); });
                break;
            case "VolumeOutlines":
                this.vr(function (ad, ae) { return ad.kz = ArrayExtension.getModulus$1(Brush.$, _this.oy, ae); });
                break;
            case "VolumeThickness":
                this.vr(function (ad, ae) { return ad.eu = _this.sf; });
                break;
            case "IndicatorNegativeBrushes":
                this.vo(function (ad, ae) { return _this.p8.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.os, ae)); });
                break;
            case "IndicatorBrushes":
                this.vo(function (ad, ae) { return ad.kw = ArrayExtension.getModulus$1(Brush.$, _this.or, ae); });
                break;
            case "IndicatorThickness":
                this.vo(function (ad, ae) { return ad.eu = _this.sc; });
                break;
            case "IndicatorDisplayTypes":
                this.vo(function (ad, ae) { return _this.p8.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.qa, ae)); });
                break;
            case "IndicatorPeriod":
                this.vo(function (ad, ae) {
                    if (_this.s1 == -2147483648 || !(_this.rb(ad))) {
                        return;
                    }
                    _this.p8.setPeriodOverride(ad, _this.s1);
                });
                break;
            case "IndicatorMultiplier":
                this.vo(function (ad, ae) {
                    if (!(_this.rd(ad))) {
                        return;
                    }
                    _this.qd.setMultiplier(ad, _this.sb);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.vo(function (ad, ae) {
                    if (!(_this.rb(ad))) {
                        return;
                    }
                    _this.p8.setSmoothingPeriod(ad, _this.s4);
                });
                break;
            case "IndicatorShortPeriod":
                this.vo(function (ad, ae) {
                    if (!(_this.rb(ad))) {
                        return;
                    }
                    _this.p8.setShortPeriod(ad, _this.s2);
                });
                break;
            case "IndicatorLongPeriod":
                this.vo(function (ad, ae) {
                    if (!(_this.rb(ad))) {
                        return;
                    }
                    _this.p8.setLongPeriod(ad, _this.s0);
                });
                break;
            case "IndicatorSignalPeriod":
                this.vo(function (ad, ae) {
                    if (!(_this.rb(ad))) {
                        return;
                    }
                    _this.p8.setSignalPeriod(ad, _this.s3);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.vz));
                }
                if (this.pg != null) {
                    var ae = this.pg;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.vz));
                }
                this.wk();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.vv));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.vv));
                }
                this.wu();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.vq(function (ah, ai) { return ah.kw = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null; }, true);
                break;
            case "Outlines":
                this.vq(function (ah, ai) { return ah.kz = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.oh == 0 && this.zoomSliderXAxis != null) {
                    this.mx(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.vl();
                break;
            case "YAxisLabelVisibility":
                if (this.oi != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.mx(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.ic = this.w5;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d0 = this.sm;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.rc && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.p2 : null;
                        }
                    };
                    this.vq(ai, false);
                    this.vp(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.wh();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bf) {
                        this.m1(this.zoomSliderAxis);
                    }
                    this.mx(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.m3(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.rz;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.m3(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.ry;
                    }
                });
                break;
        }
        var e_18, _c, e_19, _f;
    };
    Object.defineProperty(FinancialChart.prototype, "rl", {
        get: function () {
            return this.q5;
        },
        set: function (a) {
            var b = this.rl;
            if (a != b) {
                this.q5 = a;
                this.gz("YAxisIsLogarithmic", b, this.rl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s6", {
        get: function () {
            return this.sy;
        },
        set: function (a) {
            var b = this.s6;
            if (a != b) {
                this.sy = a;
                this.gz("YAxisLogarithmBase", b, this.s6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "si", {
        get: function () {
            return this.r5;
        },
        set: function (a) {
            var b = this.si;
            if (a != b) {
                this.r5 = a;
                this.gz("YAxisInterval", b, this.si);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sk", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.sk;
            if (a != b) {
                this.r7 = a;
                this.gz("YAxisMinimumValue", b, this.sk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sj", {
        get: function () {
            return this.r6;
        },
        set: function (a) {
            var b = this.sj;
            if (a != b) {
                this.r6 = a;
                this.gz("YAxisMaximumValue", b, this.sj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sl", {
        get: function () {
            return this.r8;
        },
        set: function (a) {
            var b = this.sl;
            if (a != b) {
                this.r8 = a;
                this.gz("YAxisMinorInterval", b, this.sl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sh", {
        get: function () {
            return this.yAxis.jx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sg", {
        get: function () {
            return this.yAxis.jw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pp", {
        get: function () {
            return this.pn;
        },
        set: function (a) {
            var b = this.pp;
            if (a != b) {
                this.pn = a;
                this.gz("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.pp));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pr", {
        get: function () {
            return this.pq;
        },
        set: function (a) {
            var b = this.pr;
            if (a != b) {
                this.pq = a;
                this.gz("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.pr));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pt", {
        get: function () {
            return this.ps;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.ps = a;
                this.gz("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.pt));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rg", {
        get: function () {
            return this.q2;
        },
        set: function (a) {
            var b = this.rg;
            if (a != b) {
                this.q2 = a;
                this.gz("IsToolbarVisible", b, this.rg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pk", {
        get: function () {
            return this.pj;
        },
        set: function (a) {
            var b = this.pk;
            if (a != b) {
                this.pj = a;
                this.gz("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.pk));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_ng = function () {
        return _super.prototype.get_ng.call(this);
    };
    FinancialChart.prototype.set_ng = function (a) {
        _super.prototype.set_ng.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "rh", {
        get: function () {
            return this.q3;
        },
        set: function (a) {
            var b = this.rh;
            if (a != b) {
                this.q3 = a;
                this.gz("IsWindowSyncedToVisibleRange", b, this.rh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "py", {
        get: function () {
            return this.px;
        },
        set: function (a) {
            var b = this.py;
            if (a != b) {
                this.px = a;
                this.gz("IndicatorTypes", b, this.py);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p0", {
        get: function () {
            return this.pz;
        },
        set: function (a) {
            var b = this.p0;
            if (a != b) {
                this.pz = a;
                this.gz("OverlayTypes", b, this.p0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.rp;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.rp = a;
                this.gz("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rk", {
        get: function () {
            return this.q4;
        },
        set: function (a) {
            var b = this.rk;
            if (a != b) {
                this.q4 = a;
                this.gz("YAxisAbbreviateLargeNumbers", b, this.rk);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_ct = function () {
        return _super.prototype.get_ct.call(this);
    };
    FinancialChart.prototype.set_ct = function (a) {
        _super.prototype.set_ct.call(this, a);
    };
    FinancialChart.prototype.get_ic = function () {
        return _super.prototype.get_ic.call(this);
    };
    FinancialChart.prototype.set_ic = function (a) {
        _super.prototype.set_ic.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.qw;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.qw = a;
                this.gz("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.qh;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.qh = a;
                this.gz("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.o2;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.o2 = a;
                this.gz("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pw", {
        get: function () {
            return this.pu;
        },
        set: function (a) {
            var b = this.pw;
            if (a != b) {
                this.pu = a;
                this.gz("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.pw));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ot", {
        get: function () {
            return this.ol;
        },
        set: function (a) {
            var b = this.ot;
            if (a != b) {
                this.ol = a;
                this.gz("NegativeBrushes", b, this.ot);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ou", {
        get: function () {
            return this.om;
        },
        set: function (a) {
            var b = this.ou;
            if (a != b) {
                this.om = a;
                this.gz("NegativeOutlines", b, this.ou);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ov", {
        get: function () {
            return this.on;
        },
        set: function (a) {
            var b = this.ov;
            if (a != b) {
                this.on = a;
                this.gz("OverlayBrushes", b, this.ov);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ow", {
        get: function () {
            return this.oo;
        },
        set: function (a) {
            var b = this.ow;
            if (a != b) {
                this.oo = a;
                this.gz("OverlayOutlines", b, this.ow);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oy", {
        get: function () {
            return this.oq;
        },
        set: function (a) {
            var b = this.oy;
            if (a != b) {
                this.oq = a;
                this.gz("VolumeOutlines", b, this.oy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ox", {
        get: function () {
            return this.op;
        },
        set: function (a) {
            var b = this.ox;
            if (a != b) {
                this.op = a;
                this.gz("VolumeBrushes", b, this.ox);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "os", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            var b = this.os;
            if (a != b) {
                this.ok = a;
                this.gz("IndicatorNegativeBrushes", b, this.os);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "or", {
        get: function () {
            return this.oj;
        },
        set: function (a) {
            var b = this.or;
            if (a != b) {
                this.oj = a;
                this.gz("IndicatorBrushes", b, this.or);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sf", {
        get: function () {
            return this.r4;
        },
        set: function (a) {
            var b = this.sf;
            if (a != b) {
                this.r4 = a;
                this.gz("VolumeThickness", b, this.sf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sd", {
        get: function () {
            return this.r2;
        },
        set: function (a) {
            var b = this.sd;
            if (a != b) {
                this.r2 = a;
                this.gz("OverlayThickness", b, this.sd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sc", {
        get: function () {
            return this.r1;
        },
        set: function (a) {
            var b = this.sc;
            if (a != b) {
                this.r1 = a;
                this.gz("IndicatorThickness", b, this.sc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qa", {
        get: function () {
            return this.p9;
        },
        set: function (a) {
            var b = this.qa;
            if (a != b) {
                this.p9 = a;
                this.gz("IndicatorDisplayTypes", b, this.qa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s1", {
        get: function () {
            return this.su;
        },
        set: function (a) {
            var b = this.s1;
            if (a != b) {
                this.su = a;
                this.gz("IndicatorPeriod", b, this.s1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sb", {
        get: function () {
            return this.r0;
        },
        set: function (a) {
            var b = this.sb;
            if (a != b) {
                this.r0 = a;
                this.gz("IndicatorMultiplier", b, this.sb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s4", {
        get: function () {
            return this.sx;
        },
        set: function (a) {
            var b = this.s4;
            if (a != b) {
                this.sx = a;
                this.gz("IndicatorSmoothingPeriod", b, this.s4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s2", {
        get: function () {
            return this.sv;
        },
        set: function (a) {
            var b = this.s2;
            if (a != b) {
                this.sv = a;
                this.gz("IndicatorShortPeriod", b, this.s2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s0", {
        get: function () {
            return this.st;
        },
        set: function (a) {
            var b = this.s0;
            if (a != b) {
                this.st = a;
                this.gz("IndicatorLongPeriod", b, this.s0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s3", {
        get: function () {
            return this.sw;
        },
        set: function (a) {
            var b = this.s3;
            if (a != b) {
                this.sw = a;
                this.gz("IndicatorSignalPeriod", b, this.s3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pg", {
        get: function () {
            return this.pe;
        },
        set: function (a) {
            var b = this.pg;
            if (a != b) {
                this.pe = a;
                this.gz("RangeSelectorOptions", b, this.pg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.pa;
        },
        set: function (a) {
            var b = this.pa;
            if (a != b) {
                this.pa = a;
                this.gz("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_bu = function () {
        return _super.prototype.get_bu.call(this);
    };
    FinancialChart.prototype.set_bu = function (a) {
        _super.prototype.set_bu.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "w5", {
        get: function () {
            return this.w4;
        },
        set: function (a) {
            var b = this.w5;
            if (a != b) {
                this.w4 = a;
                this.gz("ZoomSliderXAxisMajorStroke", b, this.w5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sm", {
        get: function () {
            return this.r9;
        },
        set: function (a) {
            var b = this.sm;
            if (a != b) {
                this.r9 = a;
                this.gz("ZoomSliderXAxisMajorStrokeThickness", b, this.sm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rc", {
        get: function () {
            return this.q1;
        },
        set: function (a) {
            var b = this.rc;
            if (a != b) {
                this.q1 = a;
                this.gz("IsLegendVisible", b, this.rc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p2", {
        get: function () {
            return this.p1;
        },
        set: function (a) {
            var b = this.p2;
            if (a != b) {
                this.p1 = a;
                this.gz("FinancialChartLegend", b, this.p2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.o1;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.o1 = a;
                this.gz("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.qg;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.qg = a;
                this.gz("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.qf;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.qf = a;
                this.gz("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.o0;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.o0 = a;
                this.gz("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.qe;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.qe = a;
                this.gz("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.oz;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.oz = a;
                this.gz("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rr", {
        get: function () {
            return this.ro;
        },
        set: function (a) {
            var b = this.rr;
            if (a != b) {
                this.ro = a;
                this.gz("IndicatorAxes", b, this.rr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rt", {
        get: function () {
            return this.rq;
        },
        set: function (a) {
            var b = this.rt;
            if (a != b) {
                this.rq = a;
                this.gz("IndicatorXAxes", b, this.rt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rz", {
        get: function () {
            return this.rx;
        },
        set: function (a) {
            var b = this.rz;
            if (+a != +b) {
                this.rx = a;
                this.gz("XAxisMinimumValue", b, this.rz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ry", {
        get: function () {
            return this.rw;
        },
        set: function (a) {
            var b = this.ry;
            if (+a != +b) {
                this.rw = a;
                this.gz("XAxisMaximumValue", b, this.ry);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.ru;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.s5 = 0;
    return FinancialChart;
}(XYChart));
export { FinancialChart };
var FinancialChartToolbar = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.th : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.te : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.tf : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = this.d.querySelector(".financialChartIndicatorMenu");
        this.q.g = b;
        var c = this.d.querySelector(".financialChartRangeSelector");
        this.s.g = c;
        var d = this.d.querySelector(".financialChartTypePicker");
        this.aa.g = d;
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _a = tslib_1.__values(fromEn(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_20_1) { e_20 = { error: e_20_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_20) throw e_20.error; }
        }
        return true;
        var e_20, _c;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
var FinancialChartRangeSelector = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.e(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.d(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.c(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.af();
        }
        if (this.p != null) {
            this.p.g(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map