/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, INotifyPropertyChanged_$type, BaseError, PropertyChangedEventArgs, Delegate_$type, fromEnum, String_$type, runOn, delegateCombine, EnumUtil, typeCast, delegateRemove, enumGetBox, markType, TypeRegistrar, getInstanceType } from "igniteui-angular-core/ES2015/type";
import { ArrayExtension } from "igniteui-angular-core/ES2015/ArrayExtension";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesType_$type } from "igniteui-angular-core/ES2015/DataSeriesType";
import { MarkerType_$type } from "./MarkerType";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { ColorUtil } from "igniteui-angular-core/ES2015/ColorUtil";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { HorizontalAlignment_$type } from "igniteui-angular-core/ES2015/HorizontalAlignment";
import { UnknownValuePlotting_$type } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { TrendLineType_$type } from "igniteui-angular-core/ES2015/TrendLineType";
import { ToolTipType_$type } from "./ToolTipType";
import { CrosshairsDisplayMode_$type } from "./CrosshairsDisplayMode";
import { DeviceUtils } from "igniteui-angular-core/ES2015/DeviceUtils";
import { Series } from "./Series";
import { DataSeriesAdapter } from "igniteui-angular-core/ES2015/DataSeriesAdapter";
import { ObservableCollection$1 } from "igniteui-angular-core/ES2015/ObservableCollection$1";
import { BrushCollectionUtil } from "igniteui-angular-core/ES2015/BrushCollectionUtil";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { IUnknownValuePlotting_$type } from "igniteui-angular-core/ES2015/IUnknownValuePlotting";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { Random } from "igniteui-angular-core/ES2015/Random";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
import { stringIsNullOrEmpty, stringEmpty } from "igniteui-angular-core/ES2015/string";
export class DomainChart extends Base {
    constructor() {
        super();
        this.dh = null;
        this.dg = null;
        this.bx = null;
        this.cc = NaN;
        this.df = null;
        this.cl = 0;
        this.cm = 0;
        this.cn = 0;
        this.ck = 0;
        this.cg = 0;
        this.ci = 0;
        this.ch = 0;
        this.cf = 0;
        this.ht = null;
        this.hu = null;
        this.cb = NaN;
        this.co = NaN;
        this.ce = NaN;
        this.ca = NaN;
        this.da = 0;
        this.a0 = null;
        this.c6 = null;
        this.bv = false;
        this.af = null;
        this.dv = null;
        this.dx = null;
        this.ay = null;
        this.b1 = null;
        this.propertyChanged = null;
        this.c9 = 0;
        this.bp = false;
        this.ab = null;
        this.bw = null;
        this.seriesAdded = null;
        this.seriesRemoved = null;
        this.seriesPointerEnter = null;
        this.seriesPointerLeave = null;
        this.seriesPointerMove = null;
        this.seriesPointerDown = null;
        this.seriesPointerUp = null;
        this.calloutStyleUpdating = null;
        this.b0 = null;
        this.a4 = false;
        this.b6 = null;
        this.b = null;
        this.a = null;
        this.e = null;
        this.h = null;
        this.ad = null;
        this.ba = true;
        this.bc = true;
        this.bb = false;
        this.h2 = new Rect(0, 0, 0, 1, 1);
        this.dw = null;
        this.du = null;
        this.hq = 1;
        this.hp = 1;
        this.aw = 0;
        this.cd = 1;
        this.cj = 1;
        this.aj = null;
        this.f = null;
        this.g = null;
        this.c8 = 400;
        this.a3 = false;
        this.i = null;
        this.au = 0;
        this.cp = 1.5;
        this.a2 = true;
        this.db = 7;
        this.as = 0;
        this.s = 0;
        this.a8 = true;
        this.a7 = false;
        this.a9 = false;
        this.a6 = false;
        this.a5 = false;
        this.b5 = null;
        this.ds = null;
        this.dt = null;
        this.dr = "CalloutLabel";
        this.dq = "CalloutContent";
        this.b0 = new List$1(Delegate_$type, 0);
        this.gf();
        this.f2();
    }
    provideContainer(a) {
        if (a == null) {
            this.dataChart.provideContainer(null);
            return;
        }
        this.dh = a;
        let b = ((() => {
            let $ret = new XamDataChart();
            $ret.cs = true;
            return $ret;
        })());
        b.provideContainer(a);
        this.dataChart = b;
        this.gg();
    }
    destroy() {
        this.provideContainer(null);
    }
    gg() {
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.bm.i.e();
        this.j = a.a;
        this.n = a.f;
        this.l = a.b;
        this.m = a.c;
        this.o = a.g;
        this.cz = DeviceUtils.g(1);
        this.gh();
    }
    gh() {
    }
    gd(a) {
        if (a == null) {
            return;
        }
        a.es = this.c3;
        a.eq = this.c1;
        a.er = this.c2;
        a.ep = this.c0;
        a.md = this.h0;
        a.em = this.cw;
        a.eo = this.cy;
        a.en = this.cx;
        a.el = this.cv;
        a.mc = this.hz;
        if (!isNaN_(this.cs)) {
            a.ej = this.cs;
        }
    }
    ga() {
    }
    gj(a, b) {
        a.fe = this.dd;
        a.bu = this.a1;
    }
    g0(a, b, c) {
        switch (a) {
            case "TitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.es = this.c3;
                }
                break;
            case "TitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.eq = this.c1;
                }
                break;
            case "PixelScalingRatio":
                if (this.dataChart != null) {
                    this.gu((d) => d.ej = this.cs);
                }
                break;
            case "TitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.er = this.c2;
                }
                break;
            case "TitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ep = this.c0;
                }
                break;
            case "TitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.md = this.h0;
                }
                break;
            case "SubtitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.em = this.cw;
                }
                break;
            case "SubtitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.eo = this.cy;
                }
                break;
            case "SubtitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.en = this.cx;
                }
                break;
            case "SubtitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.el = this.cv;
                }
                break;
            case "SubtitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.mc = this.hz;
                }
                break;
            case "LeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.ei = this.cr;
                }
                break;
            case "TopMargin":
                if (this.dataChart != null) {
                    this.dataChart.et = this.c4;
                }
                break;
            case "RightMargin":
                if (this.dataChart != null) {
                    this.dataChart.ek = this.cu;
                }
                break;
            case "BottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ee = this.cq;
                }
                break;
            case "TransitionDuration":
                this.f6((d) => d.fe = this.dd);
                break;
            case "TransitionEasingFunction":
                this.f6((d) => d.bu = this.a1);
                break;
        }
    }
    get tooltipTemplate() {
        return ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, 0);
    }
    set tooltipTemplate(a) {
        this.tooltipTemplates = a == null ? null : new List$1(Base.$, 1, [a]);
    }
    get tooltipTemplates() {
        return this.bx;
    }
    set tooltipTemplates(a) {
        let b = this.tooltipTemplates;
        if (a != b) {
            this.bx = a;
            this.gz("TooltipTemplates", b, this.tooltipTemplates);
        }
    }
    get cs() {
        return this.cc;
    }
    set cs(a) {
        let b = this.cc;
        if (a != b) {
            this.cc = a;
            this.gz("PixelScalingRatio", b, this.cs);
        }
    }
    get toolTip() {
        return this.df;
    }
    set toolTip(a) {
        let b = this.toolTip;
        if (b != a) {
            this.df = a;
            this.gz("ToolTip", b, this.toolTip);
        }
    }
    get c1() {
        return this.cl;
    }
    set c1(a) {
        let b = this.c1;
        if (a != b) {
            this.cl = a;
            this.gz("TitleLeftMargin", b, this.c1);
        }
    }
    get c2() {
        return this.cm;
    }
    set c2(a) {
        let b = this.c2;
        if (a != b) {
            this.cm = a;
            this.gz("TitleRightMargin", b, this.c2);
        }
    }
    get c3() {
        return this.cn;
    }
    set c3(a) {
        let b = this.c3;
        if (a != b) {
            this.cn = a;
            this.gz("TitleTopMargin", b, this.c3);
        }
    }
    get c0() {
        return this.ck;
    }
    set c0(a) {
        let b = this.c0;
        if (a != b) {
            this.ck = a;
            this.gz("TitleBottomMargin", b, this.c0);
        }
    }
    get cw() {
        return this.cg;
    }
    set cw(a) {
        let b = this.cw;
        if (a != b) {
            this.cg = a;
            this.gz("SubtitleLeftMargin", b, this.cw);
        }
    }
    get cy() {
        return this.ci;
    }
    set cy(a) {
        let b = this.cy;
        if (a != b) {
            this.ci = a;
            this.gz("SubtitleTopMargin", b, this.cy);
        }
    }
    get cx() {
        return this.ch;
    }
    set cx(a) {
        let b = this.cx;
        if (a != b) {
            this.ch = a;
            this.gz("SubtitleRightMargin", b, this.cx);
        }
    }
    get cv() {
        return this.cf;
    }
    set cv(a) {
        let b = this.cv;
        if (a != b) {
            this.cf = a;
            this.gz("SubtitleBottomMargin", b, this.cv);
        }
    }
    get hz() {
        return this.ht;
    }
    set hz(a) {
        let b = this.hz;
        if (a != b) {
            this.ht = a;
            this.gz("SubtitleTextColor", b, this.hz);
        }
    }
    get h0() {
        return this.hu;
    }
    set h0(a) {
        let b = this.h0;
        if (a != b) {
            this.hu = a;
            this.gz("TitleTextColor", b, this.h0);
        }
    }
    get_cr() {
        return this.cb;
    }
    set_cr(a) {
        let b = this.cr;
        if (a != b) {
            this.cb = a;
            this.gz("LeftMargin", b, this.cr);
        }
    }
    get cr() {
        return this.get_cr();
    }
    set cr(a) {
        this.set_cr(a);
    }
    get c4() {
        return this.co;
    }
    set c4(a) {
        let b = this.c4;
        if (a != b) {
            this.co = a;
            this.gz("TopMargin", b, this.c4);
        }
    }
    get cu() {
        return this.ce;
    }
    set cu(a) {
        let b = this.cu;
        if (a != b) {
            this.ce = a;
            this.gz("RightMargin", b, this.cu);
        }
    }
    get cq() {
        return this.ca;
    }
    set cq(a) {
        let b = this.cq;
        if (a != b) {
            this.ca = a;
            this.gz("BottomMargin", b, this.cq);
        }
    }
    get dd() {
        return this.da;
    }
    set dd(a) {
        let b = this.dd;
        if (a != b) {
            this.da = a;
            this.gz("TransitionDuration", b, this.dd);
        }
    }
    get a1() {
        return this.a0;
    }
    set a1(a) {
        let b = this.a1;
        if (a != b) {
            this.a0 = a;
            this.gz("TransitionEasingFunction", b, this.a1);
        }
    }
    ge(a) {
        if (this.dataChart == null) {
            return;
        }
        a.gv = this.fj;
        a.gj = this.e8;
    }
    gk(a, b) {
        this.gl(a, b);
    }
    gb() {
    }
    gl(a, b) {
        if (a == null) {
            return;
        }
        let toolTipTemplate_ = ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, b);
        if (toolTipTemplate_ == null) {
            a.db = true;
        }
        else {
            let series_ = a;
            a.db = false;
            series_.externalObject.tooltipTemplate = toolTipTemplate_;
        }
    }
    hn(a, b, c) {
    }
    dj(a) {
        return a;
        return null;
    }
    c7(a) {
        return null;
    }
    g1(a, b, c) {
        switch (a) {
            case "SubtitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gj = this.e8;
                }
                break;
            case "TitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gv = this.fj;
                }
                break;
            case "TooltipTemplate":
                if (this.bv) {
                    return;
                }
                this.bv = true;
                this.tooltipTemplate = this.dj(this.tooltipTemplate);
                this.bv = false;
                if (this.dataChart != null) {
                    this.dataChart.e7 = this.tooltipTemplate;
                }
                this.toolTip = this.tooltipTemplate;
                break;
            case "ToolTip":
                this.f7((d, e) => this.gl(d, e));
                break;
            case "TooltipTemplates":
                if (this.tooltipTemplates == null) {
                    break;
                }
                this.bv = true;
                this.f7((d, e) => {
                    let f = this.dj(ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, e));
                    let series_ = d;
                    let templ_ = f;
                    series_.externalObject.tooltipTemplate = templ_;
                });
                this.bv = false;
                break;
        }
    }
    get ag() {
        return this.af;
    }
    set ag(a) {
        let b = this.ag;
        if (a != b) {
            this.af = a;
            this.gz("Widget", b, this.ag);
        }
    }
    get e8() {
        return this.dv;
    }
    set e8(a) {
        let b = this.e8;
        if (a != b) {
            this.dv = a;
            this.gz("SubtitleTextStyle", b, this.e8);
        }
    }
    get fj() {
        return this.dx;
    }
    set fj(a) {
        let b = this.fj;
        if (a != b) {
            this.dx = a;
            this.gz("TitleTextStyle", b, this.fj);
        }
    }
    get dataChart() {
        return this.ay;
    }
    set dataChart(a) {
        let b = this.dataChart;
        if (b != a) {
            this.ay = a;
            this.gz("DataChart", b, this.dataChart);
        }
    }
    gf() {
        this.b1 = new List$1(MarkerType_$type, 0);
        this.v = new DataSeriesAdapter().e;
        if (this.d != null) {
            this.v.includedProperties = this.d;
        }
        if (this.c != null) {
            this.v.excludedProperties = this.c;
        }
        this.v.supportedSeriesTypes = this.b3.toArray();
        this.v.rules.clear();
        for (let a of fromEnum(this.b2)) {
            this.v.rules.add(a);
        }
        let b = new List$1(String_$type, 0);
        for (let c of fromEnum(this.v.rules)) {
            b.add(getInstanceType(c).typeName);
        }
        let d = this.v.dataSeries;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.gx));
    }
    br(a) {
        return a != 24 && this.b3.contains(a);
    }
    notifyResized() {
        this.gu((a) => a.notifyContainerResized());
    }
    gt() {
        this.gu((a) => {
            for (let b = 0; b < a.series.count; b++) {
                a.series._inner[b].id();
            }
        });
    }
    f5() {
        if (this.dataChart == null) {
            return;
        }
        if (this.bp) {
            this.hh();
        }
        this.dataChart.flush();
    }
    f8() {
        if (this.dataChart == null) {
            return;
        }
        this.dataChart.hm();
    }
    g6(a) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    f6(a) {
        this.f7((b, c) => a(b));
    }
    f7(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            a(this.dataChart.series._inner[b], b);
        }
    }
    gu(a) {
        this.gv(a, true);
    }
    gv(a, b) {
        this.gw(a, b, null);
    }
    gw(a, b, c) {
        if (this.dataChart == null) {
            return;
        }
        a(this.dataChart);
    }
    bs(a) {
        if (!this.br(a.suggestedSeries)) {
            return false;
        }
        let b = a.data;
        if (b == null) {
            return false;
        }
        return true;
    }
    bn() {
        if (this.dataChart == null) {
            return false;
        }
        return true;
    }
    ek(a) {
        let b = "series_" + (this.dataChart.series.count + 1) + "_" + EnumUtil.getName(DataSeriesType_$type, a.suggestedSeries);
        return b;
    }
    el(a, b) {
        if (stringIsNullOrEmpty(a.title)) {
            let c = EnumUtil.getName(DataSeriesType_$type, b);
            return c + (this.dataChart.series.count + 1);
        }
        else {
            return a.title;
        }
    }
    ej() {
        return stringEmpty();
    }
    hh() {
        if (this.dataChart == null) {
            return;
        }
        this.bp = false;
        this.hj();
        if (this.itemsSource == null) {
            return;
        }
        let a = new List$1(MarkerType_$type, 0);
        for (let b of fromEnum(this.v.dataSeries)) {
            a.add(this.ah(b.suggestedMarker));
        }
        this.b1 = a;
        let c = 0;
        for (let d of fromEnum(this.v.dataSeries)) {
            if (!this.bs(d)) {
                continue;
            }
            if (d.index < 0) {
                d.index = c;
            }
            this.hf(d);
            this.hg(d);
            c++;
        }
        this.ho();
        this.f7(runOn(this, this.gi));
    }
    ar(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    al() {
        return this.ar(28);
    }
    an() {
        return this.ar(27);
    }
    ao() {
        return this.ar(29);
    }
    ap() {
        return this.ar(25);
    }
    am() {
        return this.ar(26);
    }
    get ac() {
        if (TypeRegistrar.isRegistered("AnnotationLayerProxy")) {
            return TypeRegistrar.create("AnnotationLayerProxy");
        }
        else {
            throw new BaseError(1, "annoation layer module is not loaded, but is required.");
        }
    }
    get bl() {
        return (TypeRegistrar.isRegistered("AnnotationLayerProxy"));
    }
    bm(a) {
        if (!this.bl) {
            return false;
        }
        return this.ac.matchesType(a);
    }
    ho() {
        let a = this.bz("", true);
        if (a != null) {
            for (let b = 0; b < a.count; b++) {
                this.dataChart.series.add(a._inner[b]);
            }
        }
    }
    bz(a, b) {
        if (!this.bl) {
            return null;
        }
        let c = new List$1(Series.$, 0);
        if (b) {
            if (this.a6) {
                let d = 1;
                if (this.b5 == null) {
                    for (let e of fromEnum(this.dataChart.series)) {
                        let f = this.al();
                        this.ac.setTargetSeries(f, e);
                        this.ac.setCollisionChannel(f, "MainChartCollisionChannel");
                        this.hm(f, e, this.v.dataSeries._inner[d - 1]);
                        f.name = a + getInstanceType(f).typeName + d.toString();
                        c.add(f);
                        d++;
                    }
                    ;
                }
                else {
                    let g = this.al();
                    this.hm(g, null, this.v.dataSeries._inner[d - 1]);
                    g.name = a + getInstanceType(g).typeName + d.toString();
                    c.add(g);
                }
            }
        }
        switch (this.s) {
            case 4:
            case 3:
            case 2:
                {
                    let h = this.an();
                    this.ac.setUseInterpolation(h, !this.a8);
                    this.ac.setHorizontalLineVisibility(h, (this.s == 2 || this.s == 4) ? 0 : 1);
                    this.ac.setVerticalLineVisibility(h, (this.s == 3 || this.s == 4) ? 0 : 1);
                    this.ac.setIsAxisAnnotationEnabled(h, this.a7);
                    c.add(h);
                    break;
                }
            case 1:
            case 0:
                {
                    break;
                }
        }
        if (this.a9) {
            let i = this.ao();
            c.add(i);
        }
        if (b) {
            switch (this.as) {
                case 1:
                    {
                        let j = this.ap();
                        c.add(j);
                        break;
                    }
                case 2:
                    {
                        let k = this.am();
                        c.add(k);
                        break;
                    }
                case 3:
                    {
                        this.f6((l) => l.db = false);
                        break;
                    }
                case 0:
                    {
                        this.f6((l) => l.db = true);
                        break;
                    }
            }
        }
        for (let l of fromEnum(c)) {
            if (stringIsNullOrEmpty(l.name) == false) {
                continue;
            }
            l.name = a + getInstanceType(l).typeName;
        }
        return c;
    }
    hm(a, b, c) {
        a.itemsSource = this.b5 != null ? this.b5 : b.itemsSource;
        this.ac.setXMemberPath(a, this.ds);
        this.ac.setYMemberPath(a, this.dt);
        this.ac.setLabelMemberPath(a, this.dr);
        this.ac.setContentMemberPath(a, this.dq);
    }
    hj() {
        this.hk(this.dataChart);
    }
    hk(a) {
        if (a != null && a == this.dataChart) {
            this.hi();
        }
        if (a == null || a.series.count == 0) {
            return;
        }
        this.f6((b) => {
            if (this.bm(b) && this.ac.isCalloutLayer(b)) {
                this.ac.removeCalloutStyleUpdating(b, runOn(this, this.g5));
            }
            this.hd(b);
        });
        for (let b of fromEnum(a.series)) {
            this.hl(b);
        }
        a.series.clear();
    }
    hl(a) {
        a.itemsSource = null;
        a.legend = null;
        a.hm();
    }
    gx(a, b) {
        if (this.dataChart == null) {
            return;
        }
        let c = b.oldItems == null ? "null" : b.oldItems.count.toString();
        let d = b.newItems == null ? "null" : b.newItems.count.toString();
        if (this.bp) {
            return;
        }
        let e = this.g4(runOn(this, this.hh), this.bp);
        this.bp = e.p1;
    }
    hv(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.j, a);
    }
    hy(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.n, a);
    }
    hw(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.l, a);
    }
    hx(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.m, a);
    }
    h1(a) {
        let b = new Color();
        if (this.j == null || this.j.count == 0) {
            b = ArrayExtension.getModulus$1(Color.$, this.by, a);
        }
        else {
            let c = ArrayExtension.getModulus$1(Brush.$, this.j, a);
            if (c == null) {
                b = ArrayExtension.getModulus$1(Color.$, this.by, a);
            }
            else {
                b = ColorUtil.j(c);
            }
        }
        return b;
    }
    b9(a) {
        let b = new ObservableCollection$1(Color.$, 0);
        b.add(ColorUtil.o(a, 0.5));
        b.add(a);
        return b;
    }
    k(a) {
        let b = this.b9(a);
        let c = BrushCollectionUtil.a(b);
        return c;
    }
    get by() {
        if (this.bw != null) {
            return this.bw;
        }
        this.bw = new List$1(Color.$, 0);
        this.bw.add(ColorUtil.k("#FF7446B9"));
        this.bw.add(ColorUtil.k("#FF9FB328"));
        this.bw.add(ColorUtil.k("#FFF96232"));
        this.bw.add(ColorUtil.k("#FF2E9CA6"));
        this.bw.add(ColorUtil.k("#FFDC3F76"));
        this.bw.add(ColorUtil.k("#FFFF9800"));
        this.bw.add(ColorUtil.k("#FF3F51B5"));
        this.bw.add(ColorUtil.k("#FF439C47"));
        this.bw.add(ColorUtil.k("#FF795548"));
        this.bw.add(ColorUtil.k("#FF494747"));
        return this.bw;
    }
    di() {
        if (this.dataChart == null) {
            return null;
        }
        return this.dataChart.ob();
    }
    gm(a, b) {
    }
    gn(a, b, c) {
    }
    ah(a) {
        if (a == 2) {
            return 3;
        }
        else if (a == 12) {
            return 13;
        }
        else if (a == 6) {
            return 7;
        }
        else if (a == 8) {
            return 9;
        }
        else if (a == 11) {
            return 12;
        }
        else if (a == 1) {
            return 1;
        }
        else if (a == 7) {
            return 8;
        }
        else if (a == 10) {
            return 11;
        }
        else if (a == 4) {
            return 5;
        }
        else if (a == 5) {
            return 6;
        }
        else if (a == 9) {
            return 10;
        }
        else if (a == 3) {
            return 4;
        }
        return 2;
    }
    gs(source_, a, b, c) {
        if (this.v != null) {
            this.v.notifySetItem(source_, a, b, c);
        }
        if (this.dataChart != null) {
            this.dataChart.hy(source_, a, b, c);
        }
    }
    go(source_) {
        if (this.v != null) {
            this.v.notifyClearItems(source_);
        }
        if (this.dataChart != null) {
            this.dataChart.ht(source_);
        }
    }
    gp(source_, a, b) {
        if (this.v != null) {
            this.v.notifyInsertItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hw(source_, a, b);
        }
    }
    gq(source_, a, b) {
        if (this.v != null) {
            this.v.notifyRemoveItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hx(source_, a, b);
        }
    }
    g7(a) {
        if (this.seriesAdded != null && a != null) {
            this.seriesAdded(this, new ChartSeriesEventArgs(a));
        }
    }
    hd(a) {
        if (this.seriesRemoved != null && a != null) {
            this.seriesRemoved(this, new ChartSeriesEventArgs(a));
        }
    }
    g9(a, b) {
        if (this.seriesPointerEnter != null && a != null) {
            this.seriesPointerEnter(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    ha(a, b) {
        if (this.seriesPointerLeave != null && a != null) {
            this.seriesPointerLeave(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    hb(a, b) {
        if (this.seriesPointerMove != null && a != null) {
            this.seriesPointerMove(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    g8(a, b) {
        if (this.seriesPointerDown != null && a != null) {
            this.seriesPointerDown(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    hc(a, b) {
        if (this.seriesPointerUp != null && a != null) {
            this.seriesPointerUp(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    g5(a, b) {
        if (this.calloutStyleUpdating != null && a != null) {
            this.calloutStyleUpdating(this, b);
        }
    }
    g3(a) {
        if (!this.b0.contains(a)) {
            this.b0.add(a);
            let b = false;
            let c = this.g4(() => {
                a();
                this.b0.remove(a);
            }, b);
            b = c.p1;
        }
    }
    g4(a, b) {
        if (!b) {
            b = true;
            if (this.dh != null) {
                this.dh.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        return {
            p1: b
        };
    }
    get_bt() {
        return true;
    }
    get bt() {
        return this.get_bt();
    }
    gc(a) {
        let b = a == this.dataChart;
        if (b) {
            a.m6 = this.j;
        }
        if (b) {
            a.m9 = this.n;
        }
        a.m7 = this.l;
        a.m8 = this.m;
        a.legend = this.legend;
        a.no = this.bo;
        a.nq = this.bu && this.bt;
        a.seriesMouseEnter = delegateCombine(a.seriesMouseEnter, (c, d) => this.g9(d.series, d.item));
        a.seriesMouseLeave = delegateCombine(a.seriesMouseLeave, (c, d) => this.ha(d.series, d.item));
        a.seriesMouseMove = delegateCombine(a.seriesMouseMove, (c, d) => this.hb(d.series, d.item));
        a.seriesMouseLeftButtonDown = delegateCombine(a.seriesMouseLeftButtonDown, (c, d) => this.g8(d.series, d.item));
        a.seriesMouseLeftButtonUp = delegateCombine(a.seriesMouseLeftButtonUp, (c, d) => this.hc(d.series, d.item));
        if (b) {
            a.m1 = this.h4;
        }
        if (b) {
            a.go = this.fc;
        }
        a.lw = this.hs;
        if (b) {
            a.gc = this.e1;
        }
        a.lv = this.hr;
        a.nk = this.bd;
        a.cc = this.be;
        a.ei = this.cr;
        a.ek = this.cu;
        a.et = this.c4;
        a.ee = this.cq;
        if (a == this.dataChart) {
            this.hh();
        }
        this.gd(a);
        this.ge(a);
    }
    gi(a, b) {
        if (!isNaN_(this.ct)) {
            a.eq = this.ct;
        }
        a.eu = this.cz;
        if (a.isUsableInLegend) {
            a.legend = this.legend;
        }
        if (typeCast(IUnknownValuePlotting_$type, a) !== null) {
            a.unknownValuePlotting = this.ax;
        }
        a.cu = this.bq;
        if (this.bm(a) && this.ac.isCalloutLayer(a)) {
            this.ac.setCalloutStyleUpdatingEventEnabled(a, this.bg);
            this.ac.addCalloutStyleUpdating(a, runOn(this, this.g5));
        }
        this.f0(a, b);
        this.f1(a, b);
        this.gj(a, b);
        this.gk(a, b);
        this.g7(a);
    }
    get bf() {
        return this.a4;
    }
    f4() {
        if (!this.a4) {
            this.a4 = true;
            this.f9();
        }
    }
    f9() {
        this.ga();
        this.gb();
    }
    he(a) {
        this.hk(a);
    }
    f1(a, b) {
        let c = typeCast(ITrendLineSeries_$type, a);
        if (c != null) {
            c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
            c.trendLineThickness = this.c5;
            c.trendLineType = this.av;
            c.trendLinePeriod = this.de;
        }
    }
    ai(a, b) {
        if (this.ak == null || this.ak.count == 0) {
            if (this.b1 == null || this.b1.count == 0) {
                return a != null && a.cy ? 1 : 2;
            }
            let c = ArrayExtension.getModulus$1(MarkerType_$type, this.b1, b);
            return c == 2 && a != null && a.cy ? 1 : c;
        }
        return ArrayExtension.getModulus$1(MarkerType_$type, this.ak, b);
    }
    gz(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case "DataChart":
                this.he(typeCast(XamDataChart.$, b));
                this.gc(typeCast(XamDataChart.$, c));
                break;
            case "ItemsSource":
                this.v.itemsSource = this.itemsSource;
                break;
            case "IncludedProperties":
                this.v.includedProperties = this.d;
                break;
            case "ExcludedProperties":
                this.v.excludedProperties = this.c;
                break;
            case "Brushes":
                this.gw((d) => d.m6 = this.j, true, a);
                break;
            case "Outlines":
                this.gw((d) => d.m9 = this.n, true, a);
                break;
            case "Legend":
                this.gu((d) => d.legend = this.legend);
                break;
            case "IsHorizontalZoomEnabled":
                this.gu((d) => d.no = this.bo);
                break;
            case "IsVerticalZoomEnabled":
                this.gu((d) => d.nq = this.bu);
                break;
            case "WindowRect":
                this.gv((d) => d.m1 = this.h4, false);
                break;
            case "Title":
                this.gv((d) => d.go = this.fc, false);
                break;
            case "Subtitle":
                this.gv((d) => d.gc = this.e1, false);
                break;
            case "TitleAlignment":
                this.gu((d) => d.lw = this.hs);
                break;
            case "SubtitleAlignment":
                this.gu((d) => d.lv = this.hr);
                break;
            case "UnknownValuePlotting":
                this.f6((d) => {
                    if (typeCast(IUnknownValuePlotting_$type, d) !== null) {
                        d.unknownValuePlotting = this.ax;
                    }
                });
                break;
            case "IsSeriesHighlightingEnabled":
                this.f6((d) => d.cu = this.bq);
                break;
            case "Thickness":
                this.f6((d) => d.eu = this.cz);
                break;
            case "Resolution":
                if (!isNaN_(this.ct)) {
                    this.f6((d) => d.eq = this.ct);
                }
                break;
            case "TrendLineBrushes":
            case "TrendLineType":
            case "TrendLineThickness":
            case "TrendLinePeriod":
                this.f7((d, e) => this.f1(d, e));
                break;
            case "MarkerMaxCount":
                this.f7((d, e) => this.f0(d, e));
                break;
            case "MarkerTypes":
                let d = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), b);
                if (d != null) {
                    d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.gy));
                }
                let e = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), c);
                if (e != null) {
                    e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.gy));
                }
                this.f7((f, g) => this.f0(f, g));
                break;
            case "MarkerBrushes":
                this.gu((f) => f.m7 = this.l);
                break;
            case "MarkerOutlines":
                this.gu((f) => f.m8 = this.m);
                break;
            case "AlignsGridLinesToPixels":
                this.gu((f) => f.nk = this.bd);
                break;
            case "AnimateSeriesWhenAxisRangeChanges":
                this.gu((f) => f.cc = this.be);
                break;
            case "ToolTipType":
            case "CrosshairsDisplayMode":
            case "CrosshairsSnapToData":
            case "CrosshairsAnnotationEnabled":
            case "FinalValueAnnotationsVisible":
            case "CalloutsVisible":
            case "CalloutsItemsSource":
            case "CalloutsXMemberPath":
            case "CalloutsYMemberPath":
            case "CalloutsLabelMemberPath":
            case "CalloutsContentMemberPath":
                let f = this.g4(runOn(this, this.hh), this.bp);
                this.bp = f.p1;
                break;
        }
        this.g0(a, b, c);
        this.g1(a, b, c);
    }
    gy(a, b) {
        this.f7((c, d) => this.f0(c, d));
    }
    get itemsSource() {
        return this.b6;
    }
    set itemsSource(a) {
        let b = this.itemsSource;
        if (b != a) {
            this.b6 = a;
            this.gz("ItemsSource", b, this.itemsSource);
        }
    }
    get d() {
        return this.b;
    }
    set d(a) {
        let b = this.b;
        this.b = a;
        if (b != this.b) {
            this.gz("IncludedProperties", b, this.b);
        }
    }
    get c() {
        return this.a;
    }
    set c(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.gz("ExcludedProperties", b, this.a);
        }
    }
    get j() {
        return this.e;
    }
    set j(a) {
        let b = this.j;
        if (a != b) {
            this.e = a;
            this.gz("Brushes", b, this.j);
        }
    }
    get n() {
        return this.h;
    }
    set n(a) {
        let b = this.n;
        if (a != b) {
            this.h = a;
            this.gz("Outlines", b, this.n);
        }
    }
    get legend() {
        return this.ad;
    }
    set legend(a) {
        let b = this.legend;
        if (a != b) {
            this.ad = a;
            this.gz("Legend", b, this.legend);
        }
    }
    get_bo() {
        return this.ba;
    }
    set_bo(a) {
        let b = this.bo;
        if (a != b) {
            this.ba = a;
            this.gz("IsHorizontalZoomEnabled", b, this.bo);
        }
    }
    get bo() {
        return this.get_bo();
    }
    set bo(a) {
        this.set_bo(a);
    }
    get_bu() {
        return this.bc;
    }
    set_bu(a) {
        let b = this.bu;
        if (a != b) {
            this.bc = a;
            this.gz("IsVerticalZoomEnabled", b, this.bu);
        }
    }
    get bu() {
        return this.get_bu();
    }
    set bu(a) {
        this.set_bu(a);
    }
    get_bq() {
        return this.bb;
    }
    set_bq(a) {
        let b = this.bq;
        if (a != b) {
            this.bb = a;
            this.gz("IsSeriesHighlightingEnabled", b, this.bq);
        }
    }
    get bq() {
        return this.get_bq();
    }
    set bq(a) {
        this.set_bq(a);
    }
    get h4() {
        return this.h2;
    }
    set h4(a) {
        let b = this.h4;
        if (Rect.l_op_Inequality(a, b)) {
            this.h2 = a;
            this.gz("WindowRect", b, this.h4);
        }
    }
    get h3() {
        return this.dataChart != null ? this.dataChart.m0 : Rect.empty;
    }
    get fc() {
        return this.dw;
    }
    set fc(a) {
        let b = this.fc;
        if (a != b) {
            this.dw = a;
            this.gz("Title", b, this.fc);
        }
    }
    get e1() {
        return this.du;
    }
    set e1(a) {
        let b = this.e1;
        if (a != b) {
            this.du = a;
            this.gz("Subtitle", b, this.e1);
        }
    }
    get hs() {
        return this.hq;
    }
    set hs(a) {
        let b = this.hs;
        if (b != a) {
            this.hq = a;
            this.gz("TitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hs));
        }
    }
    get hr() {
        return this.hp;
    }
    set hr(a) {
        let b = this.hr;
        if (b != a) {
            this.hp = a;
            this.gz("SubtitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hr));
        }
    }
    get ax() {
        return this.aw;
    }
    set ax(a) {
        let b = this.ax;
        if (a != b) {
            this.aw = a;
            this.gz("UnknownValuePlotting", enumGetBox(UnknownValuePlotting_$type, b), enumGetBox(UnknownValuePlotting_$type, this.ax));
        }
    }
    get_ct() {
        return this.cd;
    }
    set_ct(a) {
        let b = this.ct;
        if (a != b) {
            this.cd = a;
            this.gz("Resolution", b, this.ct);
        }
    }
    get ct() {
        return this.get_ct();
    }
    set ct(a) {
        this.set_ct(a);
    }
    get cz() {
        return this.cj;
    }
    set cz(a) {
        let b = this.cz;
        if (a != b) {
            this.cj = a;
            this.gz("Thickness", b, this.cz);
        }
    }
    get ak() {
        return this.aj;
    }
    set ak(a) {
        let b = this.ak;
        if (a != b) {
            this.aj = a;
            this.gz("MarkerTypes", b, this.ak);
        }
    }
    get l() {
        return this.f;
    }
    set l(a) {
        let b = this.l;
        if (a != b) {
            this.f = a;
            this.gz("MarkerBrushes", b, this.l);
        }
    }
    get m() {
        return this.g;
    }
    set m(a) {
        let b = this.m;
        if (!Base.equalsStatic(a, b)) {
            this.g = a;
            this.gz("MarkerOutlines", b, this.m);
        }
    }
    get dc() {
        return this.c8;
    }
    set dc(a) {
        let b = this.c8;
        if (a != b) {
            this.c8 = a;
            this.gz("MarkerMaxCount", b, this.c8);
        }
    }
    get be() {
        return this.a3;
    }
    set be(a) {
        let b = this.a3;
        if (a != b) {
            this.a3 = a;
            this.gz("AnimateSeriesWhenAxisRangeChanges", b, this.a3);
        }
    }
    get o() {
        return this.i;
    }
    set o(a) {
        let b = this.o;
        if (a != b) {
            this.i = a;
            this.gz("TrendLineBrushes", b, this.o);
        }
    }
    get av() {
        return this.au;
    }
    set av(a) {
        let b = this.av;
        if (a != b) {
            this.au = a;
            this.gz("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.av));
        }
    }
    get c5() {
        return this.cp;
    }
    set c5(a) {
        let b = this.c5;
        if (a != b) {
            this.cp = a;
            this.gz("TrendLineThickness", b, this.c5);
        }
    }
    get bd() {
        return this.a2;
    }
    set bd(a) {
        let b = this.bd;
        if (a != b) {
            this.a2 = a;
            this.gz("AlignsGridLinesToPixels", b, this.bd);
        }
    }
    get de() {
        return this.db;
    }
    set de(a) {
        let b = this.de;
        if (a != b) {
            this.db = a;
            this.gz("TrendLinePeriod", b, this.de);
        }
    }
    get at() {
        return this.as;
    }
    set at(a) {
        let b = this.at;
        if (a != b) {
            this.as = a;
            this.gz("ToolTipType", enumGetBox(ToolTipType_$type, b), enumGetBox(ToolTipType_$type, this.at));
        }
    }
    get t() {
        return this.s;
    }
    set t(a) {
        let b = this.t;
        if (a != b) {
            this.s = a;
            this.gz("CrosshairsDisplayMode", enumGetBox(CrosshairsDisplayMode_$type, b), enumGetBox(CrosshairsDisplayMode_$type, this.t));
        }
    }
    get bj() {
        return this.a8;
    }
    set bj(a) {
        let b = this.bj;
        if (a != b) {
            this.a8 = a;
            this.gz("CrosshairsSnapToData", b, this.bj);
        }
    }
    get bi() {
        return this.a7;
    }
    set bi(a) {
        let b = this.bi;
        if (a != b) {
            this.a7 = a;
            this.gz("CrosshairsAnnotationEnabled", b, this.bi);
        }
    }
    get bk() {
        return this.a9;
    }
    set bk(a) {
        let b = this.bk;
        if (a != b) {
            this.a9 = a;
            this.gz("FinalValueAnnotationsVisible", b, this.bk);
        }
    }
    get bh() {
        return this.a6;
    }
    set bh(a) {
        let b = this.bh;
        if (a != b) {
            this.a6 = a;
            this.gz("CalloutsVisible", b, this.bh);
        }
    }
    get bg() {
        return this.a5;
    }
    set bg(a) {
        let b = this.bg;
        if (a != b) {
            this.a5 = a;
            this.gz("CalloutStyleUpdatingEventEnabled", b, this.bg);
        }
    }
    get calloutsItemsSource() {
        return this.b5;
    }
    set calloutsItemsSource(a) {
        let b = this.calloutsItemsSource;
        if (a != b) {
            this.b5 = a;
            this.gz("CalloutsItemsSource", b, this.calloutsItemsSource);
        }
    }
    get d9() {
        return this.ds;
    }
    set d9(a) {
        let b = this.d9;
        if (a != b) {
            this.ds = a;
            this.gz("CalloutsXMemberPath", b, this.d9);
        }
    }
    get eb() {
        return this.dt;
    }
    set eb(a) {
        let b = this.eb;
        if (a != b) {
            this.dt = a;
            this.gz("CalloutsYMemberPath", b, this.eb);
        }
    }
    get d5() {
        return this.dr;
    }
    set d5(a) {
        let b = this.d5;
        if (a != b) {
            this.dr = a;
            this.gz("CalloutsLabelMemberPath", b, this.d5);
        }
    }
    get d2() {
        return this.dq;
    }
    set d2(a) {
        let b = this.d2;
        if (a != b) {
            this.dq = a;
            this.gz("CalloutsContentMemberPath", b, this.d2);
        }
    }
}
DomainChart.$t = markType(DomainChart, 'DomainChart', Base.$, [INotifyPropertyChanged_$type]);
DomainChart.dp = new Random(0);
//# sourceMappingURL=DomainChart.js.map