import { Base, INotifyPropertyChanged, IEnumerable, Type, PropertyChangedEventArgs } from "igniteui-angular-core/ES5/type";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-angular-core/ES5/DataSeriesAdapterImplementation";
import { DataSeriesType } from "igniteui-angular-core/ES5/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-angular-core/ES5/IDataSeriesAdapterRule";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-angular-core/ES5/Color";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { IChartLegend } from "igniteui-angular-core/ES5/IChartLegend";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { HorizontalAlignment } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { UnknownValuePlotting } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { TrendLineType } from "igniteui-angular-core/ES5/TrendLineType";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { Series } from "./Series";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { DataSeries } from "igniteui-angular-core/ES5/DataSeries";
import { DataSeriesMarker } from "igniteui-angular-core/ES5/DataSeriesMarker";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged {
    static $t: Type;
    protected dh: any;
    provideContainer(a: any): void;
    destroy(): void;
    private gg();
    protected gh(): void;
    protected gd(a: XamDataChart): void;
    protected ga(): void;
    protected gj(a: Series, b: number): void;
    protected g0(a: string, b: any, c: any): void;
    private dg;
    tooltipTemplate: any;
    private bx;
    tooltipTemplates: List$1<any>;
    private cc;
    cs: number;
    private df;
    private toolTip;
    private cl;
    c1: number;
    private cm;
    c2: number;
    private cn;
    c3: number;
    private ck;
    c0: number;
    private cg;
    cw: number;
    private ci;
    cy: number;
    private ch;
    cx: number;
    private cf;
    cv: number;
    private ht;
    hz: Brush;
    private hu;
    h0: Brush;
    private cb;
    protected get_cr(): number;
    protected set_cr(a: number): void;
    cr: number;
    private co;
    c4: number;
    private ce;
    cu: number;
    private ca;
    cq: number;
    private da;
    dd: number;
    private a0;
    a1: (time: number) => number;
    protected ge(a: XamDataChart): void;
    protected gk(a: Series, b: number): void;
    protected gb(): void;
    private gl(a, b);
    c6: (arg1: HTMLElement) => any[];
    private hn(a, b, c);
    private dj(a);
    private bv;
    private c7(a);
    protected g1(a: string, b: any, c: any): void;
    private af;
    ag: IDomainChartWidget;
    private dv;
    e8: string;
    private dx;
    fj: string;
    private ay;
    dataChart: XamDataChart;
    v: DataSeriesAdapterImplementation;
    constructor();
    protected gf(): void;
    protected readonly abstract b3: List$1<DataSeriesType>;
    protected readonly abstract b2: List$1<IDataSeriesAdapterRule>;
    protected b1: List$1<MarkerType>;
    protected br(a: DataSeriesType): boolean;
    notifyResized(): void;
    gt(): void;
    f5(): void;
    f8(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected g6(a: string): void;
    protected f6(a: (arg1: Series) => void): void;
    protected f7(a: (arg1: Series, arg2: number) => void): void;
    protected gu(a: (arg1: XamDataChart) => void): void;
    protected gv(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected gw(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected bs(a: DataSeries): boolean;
    protected bn(): boolean;
    private static readonly dp;
    private c9;
    protected ek(a: DataSeries): string;
    protected el(a: DataSeries, b: DataSeriesType): string;
    protected abstract u(a: DataSeries): DataSeriesType;
    protected abstract aq(a: DataSeries, b: DataSeriesType): Series;
    ej(): string;
    private bp;
    protected hh(): void;
    protected ar(seriesType_: DataSeriesType): Series;
    private al();
    private an();
    private ao();
    private ap();
    private am();
    private ab;
    protected readonly ac: IAnnotationLayerProxy;
    private readonly bl;
    private bm(a);
    private ho();
    protected bz(a: string, b: boolean): List$1<Series>;
    protected hm(a: Series, b: Series, c: DataSeries): void;
    protected abstract hg(a: DataSeries): void;
    protected abstract hf(a: DataSeries): void;
    protected hj(): void;
    private hk(a);
    protected hl(a: Series): void;
    protected abstract hi(): void;
    private gx(a, b);
    protected hv(a: number): Brush;
    protected hy(a: number): Brush;
    protected hw(a: number): Brush;
    protected hx(a: number): Brush;
    protected h1(a: number): Color;
    protected b9(a: Color): ObservableCollection$1<Color>;
    protected k(a: Color): BrushCollection;
    protected bw: List$1<Color>;
    protected readonly by: List$1<Color>;
    di(): any;
    gm(a: string, b: string): void;
    gn(a: string, b: string, c: Series): void;
    ah(a: DataSeriesMarker): MarkerType;
    gs(source_: any, a: number, b: any, c: any): void;
    go(source_: any): void;
    gp(source_: any, a: number, b: any): void;
    gq(source_: any, a: number, b: any): void;
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    g7(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    hd(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    g9(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    ha(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    hb(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    g8(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    hc(a: Series, b: any): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    g5(a: any, b: CalloutStyleUpdatingEventArgs): void;
    private b0;
    g3(a: () => void): void;
    g4(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_bt(): boolean;
    protected readonly bt: boolean;
    protected gc(a: XamDataChart): void;
    protected gi(a: Series, b: number): void;
    protected abstract f2(): void;
    protected readonly bf: boolean;
    private a4;
    protected f4(): void;
    protected f9(): void;
    protected he(a: XamDataChart): void;
    private f1(a, b);
    protected abstract f0(a: Series, b: number): void;
    protected ai(a: Series, b: number): MarkerType;
    protected gz(a: string, b: any, c: any): void;
    private gy(a, b);
    private b6;
    itemsSource: IEnumerable;
    private b;
    d: string[];
    private a;
    c: string[];
    private e;
    j: BrushCollection;
    private h;
    n: BrushCollection;
    private ad;
    legend: IChartLegend;
    private ba;
    protected get_bo(): boolean;
    protected set_bo(a: boolean): void;
    bo: boolean;
    private bc;
    protected get_bu(): boolean;
    protected set_bu(a: boolean): void;
    bu: boolean;
    private bb;
    protected get_bq(): boolean;
    protected set_bq(a: boolean): void;
    bq: boolean;
    private h2;
    h4: Rect;
    readonly h3: Rect;
    private dw;
    fc: string;
    private du;
    e1: string;
    private hq;
    hs: HorizontalAlignment;
    private hp;
    hr: HorizontalAlignment;
    private aw;
    ax: UnknownValuePlotting;
    private cd;
    protected get_ct(): number;
    protected set_ct(a: number): void;
    ct: number;
    private cj;
    cz: number;
    private aj;
    ak: MarkerTypeCollection;
    private f;
    l: BrushCollection;
    private g;
    m: BrushCollection;
    private c8;
    dc: number;
    private a3;
    be: boolean;
    private i;
    o: BrushCollection;
    private au;
    av: TrendLineType;
    private cp;
    c5: number;
    private a2;
    bd: boolean;
    private db;
    de: number;
    private as;
    at: ToolTipType;
    private s;
    t: CrosshairsDisplayMode;
    private a8;
    bj: boolean;
    private a7;
    bi: boolean;
    private a9;
    bk: boolean;
    private a6;
    bh: boolean;
    private a5;
    bg: boolean;
    private b5;
    calloutsItemsSource: IEnumerable;
    private ds;
    d9: string;
    private dt;
    eb: string;
    private dr;
    d5: string;
    private dq;
    d2: string;
}
