/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, INotifyPropertyChanged_$type, BaseError, PropertyChangedEventArgs, Delegate_$type, fromEnum, String_$type, runOn, delegateCombine, EnumUtil, typeCast, delegateRemove, enumGetBox, markType, TypeRegistrar, getInstanceType } from "igniteui-angular-core/ES5/type";
import { ArrayExtension } from "igniteui-angular-core/ES5/ArrayExtension";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesType_$type } from "igniteui-angular-core/ES5/DataSeriesType";
import { MarkerType_$type } from "./MarkerType";
import { Color } from "igniteui-angular-core/ES5/Color";
import { ColorUtil } from "igniteui-angular-core/ES5/ColorUtil";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { HorizontalAlignment_$type } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { UnknownValuePlotting_$type } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { ToolTipType_$type } from "./ToolTipType";
import { CrosshairsDisplayMode_$type } from "./CrosshairsDisplayMode";
import { DeviceUtils } from "igniteui-angular-core/ES5/DeviceUtils";
import { Series } from "./Series";
import { DataSeriesAdapter } from "igniteui-angular-core/ES5/DataSeriesAdapter";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { BrushCollectionUtil } from "igniteui-angular-core/ES5/BrushCollectionUtil";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { IUnknownValuePlotting_$type } from "igniteui-angular-core/ES5/IUnknownValuePlotting";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { Random } from "igniteui-angular-core/ES5/Random";
import { isNaN_ } from "igniteui-angular-core/ES5/number";
import { stringIsNullOrEmpty, stringEmpty } from "igniteui-angular-core/ES5/string";
var DomainChart = /** @class */ (function (_super) {
    tslib_1.__extends(DomainChart, _super);
    function DomainChart() {
        var _this = _super.call(this) || this;
        _this.dh = null;
        _this.dg = null;
        _this.bx = null;
        _this.cc = NaN;
        _this.df = null;
        _this.cl = 0;
        _this.cm = 0;
        _this.cn = 0;
        _this.ck = 0;
        _this.cg = 0;
        _this.ci = 0;
        _this.ch = 0;
        _this.cf = 0;
        _this.ht = null;
        _this.hu = null;
        _this.cb = NaN;
        _this.co = NaN;
        _this.ce = NaN;
        _this.ca = NaN;
        _this.da = 0;
        _this.a0 = null;
        _this.c6 = null;
        _this.bv = false;
        _this.af = null;
        _this.dv = null;
        _this.dx = null;
        _this.ay = null;
        _this.b1 = null;
        _this.propertyChanged = null;
        _this.c9 = 0;
        _this.bp = false;
        _this.ab = null;
        _this.bw = null;
        _this.seriesAdded = null;
        _this.seriesRemoved = null;
        _this.seriesPointerEnter = null;
        _this.seriesPointerLeave = null;
        _this.seriesPointerMove = null;
        _this.seriesPointerDown = null;
        _this.seriesPointerUp = null;
        _this.calloutStyleUpdating = null;
        _this.b0 = null;
        _this.a4 = false;
        _this.b6 = null;
        _this.b = null;
        _this.a = null;
        _this.e = null;
        _this.h = null;
        _this.ad = null;
        _this.ba = true;
        _this.bc = true;
        _this.bb = false;
        _this.h2 = new Rect(0, 0, 0, 1, 1);
        _this.dw = null;
        _this.du = null;
        _this.hq = 1;
        _this.hp = 1;
        _this.aw = 0;
        _this.cd = 1;
        _this.cj = 1;
        _this.aj = null;
        _this.f = null;
        _this.g = null;
        _this.c8 = 400;
        _this.a3 = false;
        _this.i = null;
        _this.au = 0;
        _this.cp = 1.5;
        _this.a2 = true;
        _this.db = 7;
        _this.as = 0;
        _this.s = 0;
        _this.a8 = true;
        _this.a7 = false;
        _this.a9 = false;
        _this.a6 = false;
        _this.a5 = false;
        _this.b5 = null;
        _this.ds = null;
        _this.dt = null;
        _this.dr = "CalloutLabel";
        _this.dq = "CalloutContent";
        _this.b0 = new List$1(Delegate_$type, 0);
        _this.gf();
        _this.f2();
        return _this;
    }
    DomainChart.prototype.provideContainer = function (a) {
        if (a == null) {
            this.dataChart.provideContainer(null);
            return;
        }
        this.dh = a;
        var b = ((function () {
            var $ret = new XamDataChart();
            $ret.cs = true;
            return $ret;
        })());
        b.provideContainer(a);
        this.dataChart = b;
        this.gg();
    };
    DomainChart.prototype.destroy = function () {
        this.provideContainer(null);
    };
    DomainChart.prototype.gg = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = this.dataChart.bm.i.e();
        this.j = a.a;
        this.n = a.f;
        this.l = a.b;
        this.m = a.c;
        this.o = a.g;
        this.cz = DeviceUtils.g(1);
        this.gh();
    };
    DomainChart.prototype.gh = function () {
    };
    DomainChart.prototype.gd = function (a) {
        if (a == null) {
            return;
        }
        a.es = this.c3;
        a.eq = this.c1;
        a.er = this.c2;
        a.ep = this.c0;
        a.md = this.h0;
        a.em = this.cw;
        a.eo = this.cy;
        a.en = this.cx;
        a.el = this.cv;
        a.mc = this.hz;
        if (!isNaN_(this.cs)) {
            a.ej = this.cs;
        }
    };
    DomainChart.prototype.ga = function () {
    };
    DomainChart.prototype.gj = function (a, b) {
        a.fe = this.dd;
        a.bu = this.a1;
    };
    DomainChart.prototype.g0 = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "TitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.es = this.c3;
                }
                break;
            case "TitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.eq = this.c1;
                }
                break;
            case "PixelScalingRatio":
                if (this.dataChart != null) {
                    this.gu(function (d) { return d.ej = _this.cs; });
                }
                break;
            case "TitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.er = this.c2;
                }
                break;
            case "TitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ep = this.c0;
                }
                break;
            case "TitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.md = this.h0;
                }
                break;
            case "SubtitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.em = this.cw;
                }
                break;
            case "SubtitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.eo = this.cy;
                }
                break;
            case "SubtitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.en = this.cx;
                }
                break;
            case "SubtitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.el = this.cv;
                }
                break;
            case "SubtitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.mc = this.hz;
                }
                break;
            case "LeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.ei = this.cr;
                }
                break;
            case "TopMargin":
                if (this.dataChart != null) {
                    this.dataChart.et = this.c4;
                }
                break;
            case "RightMargin":
                if (this.dataChart != null) {
                    this.dataChart.ek = this.cu;
                }
                break;
            case "BottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ee = this.cq;
                }
                break;
            case "TransitionDuration":
                this.f6(function (d) { return d.fe = _this.dd; });
                break;
            case "TransitionEasingFunction":
                this.f6(function (d) { return d.bu = _this.a1; });
                break;
        }
    };
    Object.defineProperty(DomainChart.prototype, "tooltipTemplate", {
        get: function () {
            return ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, 0);
        },
        set: function (a) {
            this.tooltipTemplates = a == null ? null : new List$1(Base.$, 1, [a]);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "tooltipTemplates", {
        get: function () {
            return this.bx;
        },
        set: function (a) {
            var b = this.tooltipTemplates;
            if (a != b) {
                this.bx = a;
                this.gz("TooltipTemplates", b, this.tooltipTemplates);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cs", {
        get: function () {
            return this.cc;
        },
        set: function (a) {
            var b = this.cc;
            if (a != b) {
                this.cc = a;
                this.gz("PixelScalingRatio", b, this.cs);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "toolTip", {
        get: function () {
            return this.df;
        },
        set: function (a) {
            var b = this.toolTip;
            if (b != a) {
                this.df = a;
                this.gz("ToolTip", b, this.toolTip);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c1", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.c1;
            if (a != b) {
                this.cl = a;
                this.gz("TitleLeftMargin", b, this.c1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c2", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.c2;
            if (a != b) {
                this.cm = a;
                this.gz("TitleRightMargin", b, this.c2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c3", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.c3;
            if (a != b) {
                this.cn = a;
                this.gz("TitleTopMargin", b, this.c3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c0", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.c0;
            if (a != b) {
                this.ck = a;
                this.gz("TitleBottomMargin", b, this.c0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cw", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cw;
            if (a != b) {
                this.cg = a;
                this.gz("SubtitleLeftMargin", b, this.cw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cy", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.cy;
            if (a != b) {
                this.ci = a;
                this.gz("SubtitleTopMargin", b, this.cy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cx", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.cx;
            if (a != b) {
                this.ch = a;
                this.gz("SubtitleRightMargin", b, this.cx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cv", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cv;
            if (a != b) {
                this.cf = a;
                this.gz("SubtitleBottomMargin", b, this.cv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "hz", {
        get: function () {
            return this.ht;
        },
        set: function (a) {
            var b = this.hz;
            if (a != b) {
                this.ht = a;
                this.gz("SubtitleTextColor", b, this.hz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h0", {
        get: function () {
            return this.hu;
        },
        set: function (a) {
            var b = this.h0;
            if (a != b) {
                this.hu = a;
                this.gz("TitleTextColor", b, this.h0);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_cr = function () {
        return this.cb;
    };
    DomainChart.prototype.set_cr = function (a) {
        var b = this.cr;
        if (a != b) {
            this.cb = a;
            this.gz("LeftMargin", b, this.cr);
        }
    };
    Object.defineProperty(DomainChart.prototype, "cr", {
        get: function () {
            return this.get_cr();
        },
        set: function (a) {
            this.set_cr(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c4", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.c4;
            if (a != b) {
                this.co = a;
                this.gz("TopMargin", b, this.c4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cu", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.cu;
            if (a != b) {
                this.ce = a;
                this.gz("RightMargin", b, this.cu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cq", {
        get: function () {
            return this.ca;
        },
        set: function (a) {
            var b = this.cq;
            if (a != b) {
                this.ca = a;
                this.gz("BottomMargin", b, this.cq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "dd", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.dd;
            if (a != b) {
                this.da = a;
                this.gz("TransitionDuration", b, this.dd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "a1", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a1;
            if (a != b) {
                this.a0 = a;
                this.gz("TransitionEasingFunction", b, this.a1);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.ge = function (a) {
        if (this.dataChart == null) {
            return;
        }
        a.gv = this.fj;
        a.gj = this.e8;
    };
    DomainChart.prototype.gk = function (a, b) {
        this.gl(a, b);
    };
    DomainChart.prototype.gb = function () {
    };
    DomainChart.prototype.gl = function (a, b) {
        if (a == null) {
            return;
        }
        var toolTipTemplate_ = ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, b);
        if (toolTipTemplate_ == null) {
            a.db = true;
        }
        else {
            var series_ = a;
            a.db = false;
            series_.externalObject.tooltipTemplate = toolTipTemplate_;
        }
    };
    DomainChart.prototype.hn = function (a, b, c) {
    };
    DomainChart.prototype.dj = function (a) {
        return a;
        return null;
    };
    DomainChart.prototype.c7 = function (a) {
        return null;
    };
    DomainChart.prototype.g1 = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "SubtitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gj = this.e8;
                }
                break;
            case "TitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gv = this.fj;
                }
                break;
            case "TooltipTemplate":
                if (this.bv) {
                    return;
                }
                this.bv = true;
                this.tooltipTemplate = this.dj(this.tooltipTemplate);
                this.bv = false;
                if (this.dataChart != null) {
                    this.dataChart.e7 = this.tooltipTemplate;
                }
                this.toolTip = this.tooltipTemplate;
                break;
            case "ToolTip":
                this.f7(function (d, e) { return _this.gl(d, e); });
                break;
            case "TooltipTemplates":
                if (this.tooltipTemplates == null) {
                    break;
                }
                this.bv = true;
                this.f7(function (d, e) {
                    var f = _this.dj(ArrayExtension.getModulus$1(Base.$, _this.tooltipTemplates, e));
                    var series_ = d;
                    var templ_ = f;
                    series_.externalObject.tooltipTemplate = templ_;
                });
                this.bv = false;
                break;
        }
    };
    Object.defineProperty(DomainChart.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (a != b) {
                this.af = a;
                this.gz("Widget", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "e8", {
        get: function () {
            return this.dv;
        },
        set: function (a) {
            var b = this.e8;
            if (a != b) {
                this.dv = a;
                this.gz("SubtitleTextStyle", b, this.e8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "fj", {
        get: function () {
            return this.dx;
        },
        set: function (a) {
            var b = this.fj;
            if (a != b) {
                this.dx = a;
                this.gz("TitleTextStyle", b, this.fj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "dataChart", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.dataChart;
            if (b != a) {
                this.ay = a;
                this.gz("DataChart", b, this.dataChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.gf = function () {
        this.b1 = new List$1(MarkerType_$type, 0);
        this.v = new DataSeriesAdapter().e;
        if (this.d != null) {
            this.v.includedProperties = this.d;
        }
        if (this.c != null) {
            this.v.excludedProperties = this.c;
        }
        this.v.supportedSeriesTypes = this.b3.toArray();
        this.v.rules.clear();
        try {
            for (var _a = tslib_1.__values(fromEnum(this.b2)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var a = _b.value;
                this.v.rules.add(a);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var b = new List$1(String_$type, 0);
        try {
            for (var _d = tslib_1.__values(fromEnum(this.v.rules)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                b.add(getInstanceType(c).typeName);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_2) throw e_2.error; }
        }
        var d = this.v.dataSeries;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.gx));
        var e_1, _c, e_2, _f;
    };
    DomainChart.prototype.br = function (a) {
        return a != 24 && this.b3.contains(a);
    };
    DomainChart.prototype.notifyResized = function () {
        this.gu(function (a) { return a.notifyContainerResized(); });
    };
    DomainChart.prototype.gt = function () {
        this.gu(function (a) {
            for (var b = 0; b < a.series.count; b++) {
                a.series._inner[b].id();
            }
        });
    };
    DomainChart.prototype.f5 = function () {
        if (this.dataChart == null) {
            return;
        }
        if (this.bp) {
            this.hh();
        }
        this.dataChart.flush();
    };
    DomainChart.prototype.f8 = function () {
        if (this.dataChart == null) {
            return;
        }
        this.dataChart.hm();
    };
    DomainChart.prototype.g6 = function (a) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    DomainChart.prototype.f6 = function (a) {
        this.f7(function (b, c) { return a(b); });
    };
    DomainChart.prototype.f7 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            a(this.dataChart.series._inner[b], b);
        }
    };
    DomainChart.prototype.gu = function (a) {
        this.gv(a, true);
    };
    DomainChart.prototype.gv = function (a, b) {
        this.gw(a, b, null);
    };
    DomainChart.prototype.gw = function (a, b, c) {
        if (this.dataChart == null) {
            return;
        }
        a(this.dataChart);
    };
    DomainChart.prototype.bs = function (a) {
        if (!this.br(a.suggestedSeries)) {
            return false;
        }
        var b = a.data;
        if (b == null) {
            return false;
        }
        return true;
    };
    DomainChart.prototype.bn = function () {
        if (this.dataChart == null) {
            return false;
        }
        return true;
    };
    DomainChart.prototype.ek = function (a) {
        var b = "series_" + (this.dataChart.series.count + 1) + "_" + EnumUtil.getName(DataSeriesType_$type, a.suggestedSeries);
        return b;
    };
    DomainChart.prototype.el = function (a, b) {
        if (stringIsNullOrEmpty(a.title)) {
            var c = EnumUtil.getName(DataSeriesType_$type, b);
            return c + (this.dataChart.series.count + 1);
        }
        else {
            return a.title;
        }
    };
    DomainChart.prototype.ej = function () {
        return stringEmpty();
    };
    DomainChart.prototype.hh = function () {
        if (this.dataChart == null) {
            return;
        }
        this.bp = false;
        this.hj();
        if (this.itemsSource == null) {
            return;
        }
        var a = new List$1(MarkerType_$type, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.v.dataSeries)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a.add(this.ah(b.suggestedMarker));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.b1 = a;
        var c = 0;
        try {
            for (var _d = tslib_1.__values(fromEnum(this.v.dataSeries)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var d = _e.value;
                if (!this.bs(d)) {
                    continue;
                }
                if (d.index < 0) {
                    d.index = c;
                }
                this.hf(d);
                this.hg(d);
                c++;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.ho();
        this.f7(runOn(this, this.gi));
        var e_3, _c, e_4, _f;
    };
    DomainChart.prototype.ar = function (seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    };
    DomainChart.prototype.al = function () {
        return this.ar(28);
    };
    DomainChart.prototype.an = function () {
        return this.ar(27);
    };
    DomainChart.prototype.ao = function () {
        return this.ar(29);
    };
    DomainChart.prototype.ap = function () {
        return this.ar(25);
    };
    DomainChart.prototype.am = function () {
        return this.ar(26);
    };
    Object.defineProperty(DomainChart.prototype, "ac", {
        get: function () {
            if (TypeRegistrar.isRegistered("AnnotationLayerProxy")) {
                return TypeRegistrar.create("AnnotationLayerProxy");
            }
            else {
                throw new BaseError(1, "annoation layer module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bl", {
        get: function () {
            return (TypeRegistrar.isRegistered("AnnotationLayerProxy"));
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.bm = function (a) {
        if (!this.bl) {
            return false;
        }
        return this.ac.matchesType(a);
    };
    DomainChart.prototype.ho = function () {
        var a = this.bz("", true);
        if (a != null) {
            for (var b = 0; b < a.count; b++) {
                this.dataChart.series.add(a._inner[b]);
            }
        }
    };
    DomainChart.prototype.bz = function (a, b) {
        if (!this.bl) {
            return null;
        }
        var c = new List$1(Series.$, 0);
        if (b) {
            if (this.a6) {
                var d = 1;
                if (this.b5 == null) {
                    try {
                        for (var _a = tslib_1.__values(fromEnum(this.dataChart.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                            var e = _b.value;
                            var f = this.al();
                            this.ac.setTargetSeries(f, e);
                            this.ac.setCollisionChannel(f, "MainChartCollisionChannel");
                            this.hm(f, e, this.v.dataSeries._inner[d - 1]);
                            f.name = a + getInstanceType(f).typeName + d.toString();
                            c.add(f);
                            d++;
                        }
                    }
                    catch (e_5_1) { e_5 = { error: e_5_1 }; }
                    finally {
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_5) throw e_5.error; }
                    }
                    ;
                }
                else {
                    var g = this.al();
                    this.hm(g, null, this.v.dataSeries._inner[d - 1]);
                    g.name = a + getInstanceType(g).typeName + d.toString();
                    c.add(g);
                }
            }
        }
        switch (this.s) {
            case 4:
            case 3:
            case 2:
                {
                    var h = this.an();
                    this.ac.setUseInterpolation(h, !this.a8);
                    this.ac.setHorizontalLineVisibility(h, (this.s == 2 || this.s == 4) ? 0 : 1);
                    this.ac.setVerticalLineVisibility(h, (this.s == 3 || this.s == 4) ? 0 : 1);
                    this.ac.setIsAxisAnnotationEnabled(h, this.a7);
                    c.add(h);
                    break;
                }
            case 1:
            case 0:
                {
                    break;
                }
        }
        if (this.a9) {
            var i = this.ao();
            c.add(i);
        }
        if (b) {
            switch (this.as) {
                case 1:
                    {
                        var j = this.ap();
                        c.add(j);
                        break;
                    }
                case 2:
                    {
                        var k = this.am();
                        c.add(k);
                        break;
                    }
                case 3:
                    {
                        this.f6(function (l) { return l.db = false; });
                        break;
                    }
                case 0:
                    {
                        this.f6(function (l) { return l.db = true; });
                        break;
                    }
            }
        }
        try {
            for (var _d = tslib_1.__values(fromEnum(c)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var l = _e.value;
                if (stringIsNullOrEmpty(l.name) == false) {
                    continue;
                }
                l.name = a + getInstanceType(l).typeName;
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return c;
        var e_5, _c, e_6, _f;
    };
    DomainChart.prototype.hm = function (a, b, c) {
        a.itemsSource = this.b5 != null ? this.b5 : b.itemsSource;
        this.ac.setXMemberPath(a, this.ds);
        this.ac.setYMemberPath(a, this.dt);
        this.ac.setLabelMemberPath(a, this.dr);
        this.ac.setContentMemberPath(a, this.dq);
    };
    DomainChart.prototype.hj = function () {
        this.hk(this.dataChart);
    };
    DomainChart.prototype.hk = function (a) {
        var _this = this;
        if (a != null && a == this.dataChart) {
            this.hi();
        }
        if (a == null || a.series.count == 0) {
            return;
        }
        this.f6(function (b) {
            if (_this.bm(b) && _this.ac.isCalloutLayer(b)) {
                _this.ac.removeCalloutStyleUpdating(b, runOn(_this, _this.g5));
            }
            _this.hd(b);
        });
        try {
            for (var _a = tslib_1.__values(fromEnum(a.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                this.hl(b);
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_7) throw e_7.error; }
        }
        a.series.clear();
        var e_7, _c;
    };
    DomainChart.prototype.hl = function (a) {
        a.itemsSource = null;
        a.legend = null;
        a.hm();
    };
    DomainChart.prototype.gx = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        var c = b.oldItems == null ? "null" : b.oldItems.count.toString();
        var d = b.newItems == null ? "null" : b.newItems.count.toString();
        if (this.bp) {
            return;
        }
        var e = this.g4(runOn(this, this.hh), this.bp);
        this.bp = e.p1;
    };
    DomainChart.prototype.hv = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.j, a);
    };
    DomainChart.prototype.hy = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.n, a);
    };
    DomainChart.prototype.hw = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.l, a);
    };
    DomainChart.prototype.hx = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.m, a);
    };
    DomainChart.prototype.h1 = function (a) {
        var b = new Color();
        if (this.j == null || this.j.count == 0) {
            b = ArrayExtension.getModulus$1(Color.$, this.by, a);
        }
        else {
            var c = ArrayExtension.getModulus$1(Brush.$, this.j, a);
            if (c == null) {
                b = ArrayExtension.getModulus$1(Color.$, this.by, a);
            }
            else {
                b = ColorUtil.j(c);
            }
        }
        return b;
    };
    DomainChart.prototype.b9 = function (a) {
        var b = new ObservableCollection$1(Color.$, 0);
        b.add(ColorUtil.o(a, 0.5));
        b.add(a);
        return b;
    };
    DomainChart.prototype.k = function (a) {
        var b = this.b9(a);
        var c = BrushCollectionUtil.a(b);
        return c;
    };
    Object.defineProperty(DomainChart.prototype, "by", {
        get: function () {
            if (this.bw != null) {
                return this.bw;
            }
            this.bw = new List$1(Color.$, 0);
            this.bw.add(ColorUtil.k("#FF7446B9"));
            this.bw.add(ColorUtil.k("#FF9FB328"));
            this.bw.add(ColorUtil.k("#FFF96232"));
            this.bw.add(ColorUtil.k("#FF2E9CA6"));
            this.bw.add(ColorUtil.k("#FFDC3F76"));
            this.bw.add(ColorUtil.k("#FFFF9800"));
            this.bw.add(ColorUtil.k("#FF3F51B5"));
            this.bw.add(ColorUtil.k("#FF439C47"));
            this.bw.add(ColorUtil.k("#FF795548"));
            this.bw.add(ColorUtil.k("#FF494747"));
            return this.bw;
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.di = function () {
        if (this.dataChart == null) {
            return null;
        }
        return this.dataChart.ob();
    };
    DomainChart.prototype.gm = function (a, b) {
    };
    DomainChart.prototype.gn = function (a, b, c) {
    };
    DomainChart.prototype.ah = function (a) {
        if (a == 2) {
            return 3;
        }
        else if (a == 12) {
            return 13;
        }
        else if (a == 6) {
            return 7;
        }
        else if (a == 8) {
            return 9;
        }
        else if (a == 11) {
            return 12;
        }
        else if (a == 1) {
            return 1;
        }
        else if (a == 7) {
            return 8;
        }
        else if (a == 10) {
            return 11;
        }
        else if (a == 4) {
            return 5;
        }
        else if (a == 5) {
            return 6;
        }
        else if (a == 9) {
            return 10;
        }
        else if (a == 3) {
            return 4;
        }
        return 2;
    };
    DomainChart.prototype.gs = function (source_, a, b, c) {
        if (this.v != null) {
            this.v.notifySetItem(source_, a, b, c);
        }
        if (this.dataChart != null) {
            this.dataChart.hy(source_, a, b, c);
        }
    };
    DomainChart.prototype.go = function (source_) {
        if (this.v != null) {
            this.v.notifyClearItems(source_);
        }
        if (this.dataChart != null) {
            this.dataChart.ht(source_);
        }
    };
    DomainChart.prototype.gp = function (source_, a, b) {
        if (this.v != null) {
            this.v.notifyInsertItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hw(source_, a, b);
        }
    };
    DomainChart.prototype.gq = function (source_, a, b) {
        if (this.v != null) {
            this.v.notifyRemoveItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hx(source_, a, b);
        }
    };
    DomainChart.prototype.g7 = function (a) {
        if (this.seriesAdded != null && a != null) {
            this.seriesAdded(this, new ChartSeriesEventArgs(a));
        }
    };
    DomainChart.prototype.hd = function (a) {
        if (this.seriesRemoved != null && a != null) {
            this.seriesRemoved(this, new ChartSeriesEventArgs(a));
        }
    };
    DomainChart.prototype.g9 = function (a, b) {
        if (this.seriesPointerEnter != null && a != null) {
            this.seriesPointerEnter(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.ha = function (a, b) {
        if (this.seriesPointerLeave != null && a != null) {
            this.seriesPointerLeave(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.hb = function (a, b) {
        if (this.seriesPointerMove != null && a != null) {
            this.seriesPointerMove(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.g8 = function (a, b) {
        if (this.seriesPointerDown != null && a != null) {
            this.seriesPointerDown(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.hc = function (a, b) {
        if (this.seriesPointerUp != null && a != null) {
            this.seriesPointerUp(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.g5 = function (a, b) {
        if (this.calloutStyleUpdating != null && a != null) {
            this.calloutStyleUpdating(this, b);
        }
    };
    DomainChart.prototype.g3 = function (a) {
        var _this = this;
        if (!this.b0.contains(a)) {
            this.b0.add(a);
            var b = false;
            var c = this.g4(function () {
                a();
                _this.b0.remove(a);
            }, b);
            b = c.p1;
        }
    };
    DomainChart.prototype.g4 = function (a, b) {
        if (!b) {
            b = true;
            if (this.dh != null) {
                this.dh.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        return {
            p1: b
        };
    };
    DomainChart.prototype.get_bt = function () {
        return true;
    };
    Object.defineProperty(DomainChart.prototype, "bt", {
        get: function () {
            return this.get_bt();
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.gc = function (a) {
        var _this = this;
        var b = a == this.dataChart;
        if (b) {
            a.m6 = this.j;
        }
        if (b) {
            a.m9 = this.n;
        }
        a.m7 = this.l;
        a.m8 = this.m;
        a.legend = this.legend;
        a.no = this.bo;
        a.nq = this.bu && this.bt;
        a.seriesMouseEnter = delegateCombine(a.seriesMouseEnter, function (c, d) { return _this.g9(d.series, d.item); });
        a.seriesMouseLeave = delegateCombine(a.seriesMouseLeave, function (c, d) { return _this.ha(d.series, d.item); });
        a.seriesMouseMove = delegateCombine(a.seriesMouseMove, function (c, d) { return _this.hb(d.series, d.item); });
        a.seriesMouseLeftButtonDown = delegateCombine(a.seriesMouseLeftButtonDown, function (c, d) { return _this.g8(d.series, d.item); });
        a.seriesMouseLeftButtonUp = delegateCombine(a.seriesMouseLeftButtonUp, function (c, d) { return _this.hc(d.series, d.item); });
        if (b) {
            a.m1 = this.h4;
        }
        if (b) {
            a.go = this.fc;
        }
        a.lw = this.hs;
        if (b) {
            a.gc = this.e1;
        }
        a.lv = this.hr;
        a.nk = this.bd;
        a.cc = this.be;
        a.ei = this.cr;
        a.ek = this.cu;
        a.et = this.c4;
        a.ee = this.cq;
        if (a == this.dataChart) {
            this.hh();
        }
        this.gd(a);
        this.ge(a);
    };
    DomainChart.prototype.gi = function (a, b) {
        if (!isNaN_(this.ct)) {
            a.eq = this.ct;
        }
        a.eu = this.cz;
        if (a.isUsableInLegend) {
            a.legend = this.legend;
        }
        if (typeCast(IUnknownValuePlotting_$type, a) !== null) {
            a.unknownValuePlotting = this.ax;
        }
        a.cu = this.bq;
        if (this.bm(a) && this.ac.isCalloutLayer(a)) {
            this.ac.setCalloutStyleUpdatingEventEnabled(a, this.bg);
            this.ac.addCalloutStyleUpdating(a, runOn(this, this.g5));
        }
        this.f0(a, b);
        this.f1(a, b);
        this.gj(a, b);
        this.gk(a, b);
        this.g7(a);
    };
    Object.defineProperty(DomainChart.prototype, "bf", {
        get: function () {
            return this.a4;
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.f4 = function () {
        if (!this.a4) {
            this.a4 = true;
            this.f9();
        }
    };
    DomainChart.prototype.f9 = function () {
        this.ga();
        this.gb();
    };
    DomainChart.prototype.he = function (a) {
        this.hk(a);
    };
    DomainChart.prototype.f1 = function (a, b) {
        var c = typeCast(ITrendLineSeries_$type, a);
        if (c != null) {
            c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
            c.trendLineThickness = this.c5;
            c.trendLineType = this.av;
            c.trendLinePeriod = this.de;
        }
    };
    DomainChart.prototype.ai = function (a, b) {
        if (this.ak == null || this.ak.count == 0) {
            if (this.b1 == null || this.b1.count == 0) {
                return a != null && a.cy ? 1 : 2;
            }
            var c = ArrayExtension.getModulus$1(MarkerType_$type, this.b1, b);
            return c == 2 && a != null && a.cy ? 1 : c;
        }
        return ArrayExtension.getModulus$1(MarkerType_$type, this.ak, b);
    };
    DomainChart.prototype.gz = function (a, b, c) {
        var _this = this;
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case "DataChart":
                this.he(typeCast(XamDataChart.$, b));
                this.gc(typeCast(XamDataChart.$, c));
                break;
            case "ItemsSource":
                this.v.itemsSource = this.itemsSource;
                break;
            case "IncludedProperties":
                this.v.includedProperties = this.d;
                break;
            case "ExcludedProperties":
                this.v.excludedProperties = this.c;
                break;
            case "Brushes":
                this.gw(function (d) { return d.m6 = _this.j; }, true, a);
                break;
            case "Outlines":
                this.gw(function (d) { return d.m9 = _this.n; }, true, a);
                break;
            case "Legend":
                this.gu(function (d) { return d.legend = _this.legend; });
                break;
            case "IsHorizontalZoomEnabled":
                this.gu(function (d) { return d.no = _this.bo; });
                break;
            case "IsVerticalZoomEnabled":
                this.gu(function (d) { return d.nq = _this.bu; });
                break;
            case "WindowRect":
                this.gv(function (d) { return d.m1 = _this.h4; }, false);
                break;
            case "Title":
                this.gv(function (d) { return d.go = _this.fc; }, false);
                break;
            case "Subtitle":
                this.gv(function (d) { return d.gc = _this.e1; }, false);
                break;
            case "TitleAlignment":
                this.gu(function (d) { return d.lw = _this.hs; });
                break;
            case "SubtitleAlignment":
                this.gu(function (d) { return d.lv = _this.hr; });
                break;
            case "UnknownValuePlotting":
                this.f6(function (d) {
                    if (typeCast(IUnknownValuePlotting_$type, d) !== null) {
                        d.unknownValuePlotting = _this.ax;
                    }
                });
                break;
            case "IsSeriesHighlightingEnabled":
                this.f6(function (d) { return d.cu = _this.bq; });
                break;
            case "Thickness":
                this.f6(function (d) { return d.eu = _this.cz; });
                break;
            case "Resolution":
                if (!isNaN_(this.ct)) {
                    this.f6(function (d) { return d.eq = _this.ct; });
                }
                break;
            case "TrendLineBrushes":
            case "TrendLineType":
            case "TrendLineThickness":
            case "TrendLinePeriod":
                this.f7(function (d, e) { return _this.f1(d, e); });
                break;
            case "MarkerMaxCount":
                this.f7(function (d, e) { return _this.f0(d, e); });
                break;
            case "MarkerTypes":
                var d = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), b);
                if (d != null) {
                    d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.gy));
                }
                var e = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), c);
                if (e != null) {
                    e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.gy));
                }
                this.f7(function (f, g) { return _this.f0(f, g); });
                break;
            case "MarkerBrushes":
                this.gu(function (f) { return f.m7 = _this.l; });
                break;
            case "MarkerOutlines":
                this.gu(function (f) { return f.m8 = _this.m; });
                break;
            case "AlignsGridLinesToPixels":
                this.gu(function (f) { return f.nk = _this.bd; });
                break;
            case "AnimateSeriesWhenAxisRangeChanges":
                this.gu(function (f) { return f.cc = _this.be; });
                break;
            case "ToolTipType":
            case "CrosshairsDisplayMode":
            case "CrosshairsSnapToData":
            case "CrosshairsAnnotationEnabled":
            case "FinalValueAnnotationsVisible":
            case "CalloutsVisible":
            case "CalloutsItemsSource":
            case "CalloutsXMemberPath":
            case "CalloutsYMemberPath":
            case "CalloutsLabelMemberPath":
            case "CalloutsContentMemberPath":
                var f = this.g4(runOn(this, this.hh), this.bp);
                this.bp = f.p1;
                break;
        }
        this.g0(a, b, c);
        this.g1(a, b, c);
    };
    DomainChart.prototype.gy = function (a, b) {
        var _this = this;
        this.f7(function (c, d) { return _this.f0(c, d); });
    };
    Object.defineProperty(DomainChart.prototype, "itemsSource", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.itemsSource;
            if (b != a) {
                this.b6 = a;
                this.gz("ItemsSource", b, this.itemsSource);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.gz("IncludedProperties", b, this.b);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.gz("ExcludedProperties", b, this.a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "j", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.j;
            if (a != b) {
                this.e = a;
                this.gz("Brushes", b, this.j);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "n", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.n;
            if (a != b) {
                this.h = a;
                this.gz("Outlines", b, this.n);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "legend", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.legend;
            if (a != b) {
                this.ad = a;
                this.gz("Legend", b, this.legend);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bo = function () {
        return this.ba;
    };
    DomainChart.prototype.set_bo = function (a) {
        var b = this.bo;
        if (a != b) {
            this.ba = a;
            this.gz("IsHorizontalZoomEnabled", b, this.bo);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bo", {
        get: function () {
            return this.get_bo();
        },
        set: function (a) {
            this.set_bo(a);
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bu = function () {
        return this.bc;
    };
    DomainChart.prototype.set_bu = function (a) {
        var b = this.bu;
        if (a != b) {
            this.bc = a;
            this.gz("IsVerticalZoomEnabled", b, this.bu);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bu", {
        get: function () {
            return this.get_bu();
        },
        set: function (a) {
            this.set_bu(a);
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bq = function () {
        return this.bb;
    };
    DomainChart.prototype.set_bq = function (a) {
        var b = this.bq;
        if (a != b) {
            this.bb = a;
            this.gz("IsSeriesHighlightingEnabled", b, this.bq);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bq", {
        get: function () {
            return this.get_bq();
        },
        set: function (a) {
            this.set_bq(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h4", {
        get: function () {
            return this.h2;
        },
        set: function (a) {
            var b = this.h4;
            if (Rect.l_op_Inequality(a, b)) {
                this.h2 = a;
                this.gz("WindowRect", b, this.h4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h3", {
        get: function () {
            return this.dataChart != null ? this.dataChart.m0 : Rect.empty;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "fc", {
        get: function () {
            return this.dw;
        },
        set: function (a) {
            var b = this.fc;
            if (a != b) {
                this.dw = a;
                this.gz("Title", b, this.fc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "e1", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            var b = this.e1;
            if (a != b) {
                this.du = a;
                this.gz("Subtitle", b, this.e1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "hs", {
        get: function () {
            return this.hq;
        },
        set: function (a) {
            var b = this.hs;
            if (b != a) {
                this.hq = a;
                this.gz("TitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hs));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "hr", {
        get: function () {
            return this.hp;
        },
        set: function (a) {
            var b = this.hr;
            if (b != a) {
                this.hp = a;
                this.gz("SubtitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hr));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ax", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.ax;
            if (a != b) {
                this.aw = a;
                this.gz("UnknownValuePlotting", enumGetBox(UnknownValuePlotting_$type, b), enumGetBox(UnknownValuePlotting_$type, this.ax));
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_ct = function () {
        return this.cd;
    };
    DomainChart.prototype.set_ct = function (a) {
        var b = this.ct;
        if (a != b) {
            this.cd = a;
            this.gz("Resolution", b, this.ct);
        }
    };
    Object.defineProperty(DomainChart.prototype, "ct", {
        get: function () {
            return this.get_ct();
        },
        set: function (a) {
            this.set_ct(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cz", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cz;
            if (a != b) {
                this.cj = a;
                this.gz("Thickness", b, this.cz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ak", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.ak;
            if (a != b) {
                this.aj = a;
                this.gz("MarkerTypes", b, this.ak);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "l", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.l;
            if (a != b) {
                this.f = a;
                this.gz("MarkerBrushes", b, this.l);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "m", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.m;
            if (!Base.equalsStatic(a, b)) {
                this.g = a;
                this.gz("MarkerOutlines", b, this.m);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "dc", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            var b = this.c8;
            if (a != b) {
                this.c8 = a;
                this.gz("MarkerMaxCount", b, this.c8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "be", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            if (a != b) {
                this.a3 = a;
                this.gz("AnimateSeriesWhenAxisRangeChanges", b, this.a3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "o", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.o;
            if (a != b) {
                this.i = a;
                this.gz("TrendLineBrushes", b, this.o);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "av", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.av;
            if (a != b) {
                this.au = a;
                this.gz("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.av));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c5", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.c5;
            if (a != b) {
                this.cp = a;
                this.gz("TrendLineThickness", b, this.c5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bd", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.bd;
            if (a != b) {
                this.a2 = a;
                this.gz("AlignsGridLinesToPixels", b, this.bd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "de", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.de;
            if (a != b) {
                this.db = a;
                this.gz("TrendLinePeriod", b, this.de);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "at", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.at;
            if (a != b) {
                this.as = a;
                this.gz("ToolTipType", enumGetBox(ToolTipType_$type, b), enumGetBox(ToolTipType_$type, this.at));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.t;
            if (a != b) {
                this.s = a;
                this.gz("CrosshairsDisplayMode", enumGetBox(CrosshairsDisplayMode_$type, b), enumGetBox(CrosshairsDisplayMode_$type, this.t));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bj", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.bj;
            if (a != b) {
                this.a8 = a;
                this.gz("CrosshairsSnapToData", b, this.bj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bi", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.bi;
            if (a != b) {
                this.a7 = a;
                this.gz("CrosshairsAnnotationEnabled", b, this.bi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bk", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.bk;
            if (a != b) {
                this.a9 = a;
                this.gz("FinalValueAnnotationsVisible", b, this.bk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bh", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.bh;
            if (a != b) {
                this.a6 = a;
                this.gz("CalloutsVisible", b, this.bh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bg", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.bg;
            if (a != b) {
                this.a5 = a;
                this.gz("CalloutStyleUpdatingEventEnabled", b, this.bg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "calloutsItemsSource", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.calloutsItemsSource;
            if (a != b) {
                this.b5 = a;
                this.gz("CalloutsItemsSource", b, this.calloutsItemsSource);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d9", {
        get: function () {
            return this.ds;
        },
        set: function (a) {
            var b = this.d9;
            if (a != b) {
                this.ds = a;
                this.gz("CalloutsXMemberPath", b, this.d9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "eb", {
        get: function () {
            return this.dt;
        },
        set: function (a) {
            var b = this.eb;
            if (a != b) {
                this.dt = a;
                this.gz("CalloutsYMemberPath", b, this.eb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d5", {
        get: function () {
            return this.dr;
        },
        set: function (a) {
            var b = this.d5;
            if (a != b) {
                this.dr = a;
                this.gz("CalloutsLabelMemberPath", b, this.d5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d2", {
        get: function () {
            return this.dq;
        },
        set: function (a) {
            var b = this.d2;
            if (a != b) {
                this.dq = a;
                this.gz("CalloutsContentMemberPath", b, this.d2);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.$t = markType(DomainChart, 'DomainChart', Base.$, [INotifyPropertyChanged_$type]);
    DomainChart.dp = new Random(0);
    return DomainChart;
}(Base));
export { DomainChart };
//# sourceMappingURL=DomainChart.js.map