import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-angular-core/ES5/type";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { HorizontalAlignment } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { VerticalAlignment } from "igniteui-angular-core/ES5/VerticalAlignment";
import { Visibility } from "igniteui-angular-core/ES5/Visibility";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-angular-core/ES5/DataSeries";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected gh(): void;
    protected g0(a: string, b: any, c: any): void;
    private h7;
    h9: (item: any) => string;
    private h8;
    ia: (item: any) => string;
    private il;
    jo: number;
    private io;
    jq: number;
    private im;
    jp: number;
    private ik;
    jn: number;
    private i3;
    j5: number;
    private i5;
    j7: number;
    private i4;
    j6: number;
    private i2;
    j4: number;
    private nh;
    nv: Brush;
    private no;
    n2: Brush;
    private ix;
    jz: number;
    private je;
    kg: number;
    private iw;
    jy: number;
    private jd;
    kf: number;
    private iz;
    j1: number;
    private jg;
    ki: number;
    private iy;
    j0: number;
    private jf;
    kh: number;
    private iv;
    jx: number;
    private jc;
    ke: number;
    private nn;
    n1: Brush;
    private nu;
    n8: Brush;
    protected g1(a: string, b: any, c: any): void;
    private kn;
    k4: string;
    private kq;
    l6: string;
    private kp;
    ls: string;
    private ks;
    mu: string;
    private m0(a);
    private m2(a);
    protected hg(a: DataSeries): void;
    protected abstract h5(): Axis;
    protected abstract h6(): Axis;
    protected m3(a: (arg1: Axis) => void): void;
    protected m4(a: (arg1: Axis) => void, b: string): void;
    protected m8(a: (arg1: Axis) => void, b: boolean): void;
    protected m7(a: (arg1: Axis) => void): void;
    protected m6(a: (arg1: TitleSettings) => void): void;
    protected na(a: (arg1: TitleSettings) => void): void;
    protected m9(a: (arg1: AxisLabelSettings) => void): void;
    protected m5(a: (arg1: AxisLabelSettings) => void): void;
    jh(a: number): number;
    jj(a: number): number;
    ji(a: number): number;
    jk(a: number): number;
    protected he(a: XamDataChart): void;
    static kt(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected gc(a: XamDataChart): void;
    protected mz(a: Axis): void;
    protected m1(a: Axis): void;
    protected f9(): void;
    protected mx(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected my(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected gz(a: string, b: any, c: any): void;
    private kj;
    kl: any;
    private kk;
    km: any;
    private ni;
    nw: Brush;
    private np;
    n3: Brush;
    private ip;
    jr: number;
    private i6;
    j8: number;
    private iq;
    js: number;
    private i7;
    j9: number;
    private nk;
    ny: Brush;
    private nr;
    n5: Brush;
    private nl;
    nz: Brush;
    private ns;
    n6: Brush;
    private ir;
    jt: number;
    private i8;
    ka: number;
    private is;
    ju: number;
    private i9;
    kb: number;
    private nm;
    n0: Brush;
    private nt;
    n7: Brush;
    private it;
    jv: number;
    private ja;
    kc: number;
    private ko;
    lj: string;
    private kr;
    ml: string;
    private nj;
    nx: Brush;
    private nq;
    n4: Brush;
    private ij;
    jm: number;
    private i1;
    j3: number;
    private ii;
    jl: number;
    private i0;
    j2: number;
    private iu;
    jw: number;
    private jb;
    kd: number;
    private id;
    ig: boolean;
    private ie;
    ih: boolean;
    private nc;
    nf: HorizontalAlignment;
    private ob;
    oe: VerticalAlignment;
    private nb;
    ne: HorizontalAlignment;
    private nd;
    protected get_ng(): HorizontalAlignment;
    protected set_ng(a: HorizontalAlignment): void;
    ng: HorizontalAlignment;
    private n9;
    oc: VerticalAlignment;
    private oa;
    od: VerticalAlignment;
    private of;
    oh: Visibility;
    private og;
    oi: Visibility;
    private ib;
    protected get_ic(): AxisLabelsLocation;
    protected set_ic(a: AxisLabelsLocation): void;
    ic: AxisLabelsLocation;
}
